# ChainRulesTestUtils.jl

[![CI](https://github.com/JuliaDiff/ChainRulesTestUtils.jl/workflows/CI/badge.svg?branch=main)](https://github.com/JuliaDiff/ChainRulesTestUtils.jl/actions?query=workflow%3ACI)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![DOI](https://zenodo.org/badge/235620344.svg)](https://zenodo.org/badge/latestdoi/235620344)


[![](https://img.shields.io/badge/docs-main-blue.svg)](https://JuliaDiff.github.io/ChainRulesTestUtils.jl/dev)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaDiff.github.io/ChainRulesTestUtils.jl/stable)

> Collection of utilities for testing forward- and reverse-mode AD sensitivities.

`ChainRulesTestUtils.jl` is designed to help you test `ChainRulesCore.frule` and `ChainRulesCore.rrule` methods.
The main entry points are `ChainRulesTestUtils.frule_test`, `ChainRulesTestUtils.rrule_test`, and `ChainRulesTestUtils.test_scalar`
Currently this is done via testing the rules against numerical differentiation (using [`FiniteDifferences.jl`](https://github.com/JuliaDiff/FiniteDifferences.jl)).

`ChainRulesTestUtils.jl` is separate from [`ChainRulesCore.jl`](https://github.com/JuliaDiff/ChainRulesCore.jl) so that it can be a test-only dependency, allowing it to have potentially heavy dependencies, while keeping `ChainRulesCore.jl` as light-weight as possible.

module ChainRulesTestUtils

@nospecialize

using ChainRulesCore
using ChainRulesCore: frule, rrule
using Compat: only
using FiniteDifferences
using FiniteDifferences: to_vec
using LinearAlgebra
using Random
using Test
using Suppressor

export TestIterator
export test_approx, test_scalar, test_frule, test_rrule, generate_well_conditioned_matrix
export ⊢, rand_tangent
export @maybe_inferred
export test_method_tables

function __init__()
    init_test_inferred_setting!()

    # Try to disable backtrace scrubbing so that full failures are shown
    try
        isdefined(Test, :scrub_backtrace) || error("Test.scrub_backtrace not defined")
        @suppress begin  # mute warning about monkey-patching
            # depending on julia version or one or the other of these will be hit
            @eval Test scrub_backtrace(bt,) = bt  # make it do nothing
            @eval Test scrub_backtrace(bt, file_ts, file_t) = bt  # make it do nothing
        end
    catch err
        @warn "Failed to monkey-patch scrub_backtrace. Code is functional but stacktraces may be less useful" exception=(err, catch_backtrace())
    end
end

include("global_config.jl")

include("rand_tangent.jl")
include("generate_tangent.jl")
include("data_generation.jl")
include("iterator.jl")

include("output_control.jl")
include("check_result.jl")

include("rule_config.jl")
include("finite_difference_calls.jl")
include("testers.jl")

include("deprecated.jl")
include("global_checks.jl")
end # module

"""
    _parameters(type)
Extracts the type-parameters of the `type`.
e.g. `_parameters(Foo{A, B, C}) == [A, B, C]`
"""
_parameters(sig::UnionAll) = _parameters(sig.body)
_parameters(sig::DataType) = sig.parameters
_parameters(sig::Union) = Base.uniontypes(sig)


"""
    test_method_signature(frule|rrule, method)

Tests that the method signature is sensible.
Right now this just means checking the rule is not being applied to `DataType`, `Union`, or
`UnionAll`.
which is easy to do accidentally when writing rules for constructors.
It happens if you write e.g. `rrule(::typeof(Foo), x)` rather than `rrule(::Type{<:Foo}, x)`.
This would then actually define `rrule(::DataType, x)`. (or `UnionAll` if `Foo`
was parametric, or `Union` if `Foo` was a type alias for a `Union`)
"""
function test_method_signature end

function test_method_signature(::typeof(rrule), method::Method)
    function_type = if method.sig <: Tuple{Any, RuleConfig, Type, Vararg}
        _parameters(method.sig)[3]
    elseif method.sig <: Tuple{Any, Type, Vararg}
        _parameters(method.sig)[2]
    else
        nothing
    end

    @test_msg(
        "Bad constructor rrule. `typeof(T)` used rather than `Type{T}`. $method",
        function_type ∉ (DataType, UnionAll, Union)
    )
end

function test_method_signature(::typeof(frule), method::Method)
    function_type = if method.sig <: Tuple{Any, RuleConfig, Any, Type, Vararg}
        _parameters(method.sig)[4]
    elseif method.sig <: Tuple{Any, Any, Type, Vararg}
        _parameters(method.sig)[3]
    else
        nothing
    end

    @test_msg(
        "Bad constructor frule. `typeof(T)` used rather than `Type{T}`. $method",
        function_type ∉ (DataType, UnionAll, Union)
    )
end

"""
    test_method_tables()

Checks that the method tables for `rrule` and `frule` are sensible.
This in future may carry out a number of checks, but presently just checks to make sure that
no rules have been added to the very general `DataType`, `Union` or `UnionAll` types,
which is easy to do accidentally when writing rules for constructors.
It happens if you write e.g. `rrule(::typeof(Foo), x)` rather than `rrule(::Type{<:Foo}, x)`.
This would then actually define `rrule(::DataType, x)`. (or `UnionAll` if `Foo`
was parametric, or `Union` if `Foo` was a type alias for a `Union`)
"""
function test_method_tables()
    @testset "Sensible Constructors" begin
        # if someone wrote e.g. `rrule(::typeof(Foo), x)` rather than
        # `rrule(::Type{<:Foo}, x)` then that would actually define `rrule(::DataType, x)`
        # which would be bad. This test checks for that and fails if such a method exists.
        for method in methods(rrule)
            test_method_signature(rrule, method)
        end
        # frule
        for method in methods(frule)
            test_method_signature(frule, method)
        end
    end
end

using ChainRulesCore
using ChainRulesTestUtils
using ChainRulesTestUtils: rand_tangent
using FiniteDifferences
using LinearAlgebra
using MetaTesting
using Random
using Test

# in these meta tests, we always want to use `@inferred`
ChainRulesTestUtils.TEST_INFERRED[] = true

@testset "ChainRulesTestUtils.jl" begin
    include("iterator.jl")
    include("check_result.jl")
    include("testers.jl")
    include("data_generation.jl")
    include("rand_tangent.jl")
    include("rule_config.jl")

    include("global_checks.jl")
end

"""
    _make_jvp_call(fdm, f, y, xs, ẋs, ignores)

Call `FiniteDifferences.jvp`, with the option to ignore certain `xs`.

# Arguments
- `fdm::FiniteDifferenceMethod`: How to numerically differentiate `f`.
- `f`: The function to differentiate.
- `y`: The primal output `y=f(xs...)` or at least something of the right type
- `xs`: Inputs to `f`, such that `y = f(xs...)`.
- `ẋs`: The directional derivatives of `xs` w.r.t. some real number `t`.
- `ignores`: Collection of `Bool`s, the same length as `xs` and `ẋs`.
   If `ignores[i] === true`, then `ẋs[i]` is ignored for derivative estimation.

# Returns
- `Ω̇`: Derivative of output w.r.t. `t` estimated by finite differencing.
"""
function _make_jvp_call(fdm, f, y, xs, ẋs, ignores)
    f2 = _wrap_function(f, xs, ignores)

    ignores = collect(ignores)
    all(ignores) && return ntuple(_ -> NoTangent(), length(xs))
    sigargs = zip(xs[.!ignores], ẋs[.!ignores])
    return ProjectTo(y)(jvp(fdm, f2, sigargs...))
end

"""
    _make_j′vp_call(fdm, f, ȳ, xs, ignores) -> Tuple

Call `FiniteDifferences.j′vp`, with the option to ignore certain `xs`.

# Arguments
- `fdm::FiniteDifferenceMethod`: How to numerically differentiate `f`.
- `f`: The function to differentiate.
- `ȳ`: The adjoint w.r.t. output of `f`.
- `xs`: Inputs to `f`, such that `y = f(xs...)`.
- `ignores`: Collection of `Bool`s, the same length as `xs`.
  If `ignores[i] === true`, then `xs[i]` is ignored; `∂xs[i] === NoTangent()`.

# Returns
- `∂xs::Tuple`: Derivatives estimated by finite differencing.
"""
function _make_j′vp_call(fdm, f, ȳ, xs, ignores)
    f2 = _wrap_function(f, xs, ignores)

    ignores = collect(ignores)
    args = Any[NoTangent() for _ in 1:length(xs)]
    all(ignores) && return (args...,)
    sigargs = xs[.!ignores]
    arginds = (1:length(xs))[.!ignores]
    fd = j′vp(fdm, f2, ȳ, sigargs...)
    @assert length(fd) == length(arginds)

    for (dx, ind) in zip(fd, arginds)
        args[ind] = ProjectTo(xs[ind])(dx)
    end
    return (args...,)
end

"""
    _wrap_function(f, xs, ignores)

Return a new version of `f`, `fnew`, that ignores some of the arguments `xs`.

# Arguments
- `f`: The function to be wrapped.
- `xs`: Inputs to `f`, such that `y = f(xs...)`.
- `ignores`: Collection of `Bool`s, the same length as `xs`.
  If `ignores[i] === true`, then `xs[i]` is ignored; `∂xs[i] === NoTangent()`.
"""
function _wrap_function(f, xs, ignores)
    function fnew(sigargs...)
        callargs = Any[]
        j = 1

        for (i, (x, ignore)) in enumerate(zip(xs, ignores))
            if ignore
                push!(callargs, x)
            else
                push!(callargs, sigargs[j])
                j += 1
            end
        end
        @assert j == length(sigargs) + 1
        @assert length(callargs) == length(xs)
        return f(callargs...)
    end
    return fnew
end

"""
    test_scalar(f, z; rtol=1e-9, atol=1e-9, fdm=central_fdm(5, 1), fkwargs=NamedTuple(), check_inferred=true, kwargs...)

Given a function `f` with scalar input and scalar output, perform finite differencing checks,
at input point `z` to confirm that there are correct `frule` and `rrule`s provided.

# Arguments
- `f`: function for which the `frule` and `rrule` should be tested.
- `z`: input at which to evaluate `f` (should generally be set to an arbitrary point in the domain).

# Keyword Arguments
- `fdm`: the finite differencing method to use.
- `fkwargs` are passed to `f` as keyword arguments.
- If `check_inferred=true`, then the inferrability (type-stability) of the `frule` and `rrule` are checked.
- `testset_name`: if provided, the name of the testset used to wrap the tests.
  Otherwise it is determined from the function and argument types.
- All remaining keyword arguments are passed to `isapprox`.
"""
function test_scalar(f, z; rtol=1e-9, atol=1e-9, fdm=_fdm, fkwargs=NamedTuple(), check_inferred=true, testset_name=nothing, kwargs...)
    # To simplify some of the calls we make later lets group the kwargs for reuse
    rule_test_kwargs = (; rtol=rtol, atol=atol, fdm=fdm, fkwargs=fkwargs, check_inferred=check_inferred, kwargs...)
    isapprox_kwargs = (; rtol=rtol, atol=atol, kwargs...)
    testset_name = testset_name === nothing ? "test_scalar: $f at $z" : testset_name

    @testset "$(testset_name)" begin
        # z = x + im * y
        # Ω = u(x, y) + im * v(x, y)
        Ω = f(z; fkwargs...)

        # test jacobian using forward mode
        Δx = one(z)
        @testset "with tangent $Δx" begin
            # check ∂u_∂x and (if Ω is complex) ∂v_∂x via forward mode
            test_frule(f, z ⊢ Δx; rule_test_kwargs...)
            if z isa Complex
                # check that same tangent is produced for tangent 1.0 and 1.0 + 0.0im
                ḟ = rand_tangent(f)
                _, real_tangent = frule((ḟ, real(Δx)), f, z; fkwargs...)
                _, embedded_tangent = frule((ḟ, Δx), f, z; fkwargs...)
                test_approx(real_tangent, embedded_tangent; isapprox_kwargs...)
            end
        end
        if z isa Complex
            Δy = one(z) * im
            @testset "with tangent $Δy" begin
                # check ∂u_∂y and (if Ω is complex) ∂v_∂y via forward mode
                test_frule(f, z ⊢ Δy; rule_test_kwargs...)
            end
        end

        # test jacobian transpose using reverse mode
        Δu = one(Ω)
        @testset "with cotangent $Δu" begin
            # check ∂u_∂x and (if z is complex) ∂u_∂y via reverse mode
            test_rrule(f, z ⊢ Δx; output_tangent=Δu, rule_test_kwargs...)
            if Ω isa Complex
                # check that same cotangent is produced for cotangent 1.0 and 1.0 + 0.0im
                _, back = rrule(f, z)
                _, real_cotangent = back(real(Δu))
                _, embedded_cotangent = back(Δu)
                test_approx(real_cotangent, embedded_cotangent; isapprox_kwargs...)
            end
        end
        if Ω isa Complex
            Δv = one(Ω) * im
            @testset "with cotangent $Δv" begin
                # check ∂v_∂x and (if z is complex) ∂v_∂y via reverse mode
                test_rrule(f, z ⊢ Δx; output_tangent=Δv, rule_test_kwargs...)
            end
        end
    end  # top-level testset
end

"""
    test_frule([config::RuleConfig,] f, args..; kwargs...)

# Arguments
- `config`: defaults to `ChainRulesTestUtils.TestConfig`.
- `f`: function for which the `frule` should be tested. Its tangent can be provided using `f ⊢ ḟ`.
  (You can enter `⊢` via `\\vdash` + tab in the Julia REPL and supporting editors.)
- `args...`: either the primal args `x`, or primals and their tangents: `x ⊢ ẋ`
   - `x`: input at which to evaluate `f` (should generally be set to an arbitrary point in the domain).
   - `ẋ`: differential w.r.t. `x`; will be generated automatically if not provided.
   Non-differentiable arguments, such as indices, should have `ẋ` set as `NoTangent()`.

# Keyword Arguments
   - `output_tangent`: tangent against which to test accumulation of derivatives.
     Should be a differential for the output of `f`. Is set automatically if not provided.
   - `fdm::FiniteDifferenceMethod`: the finite differencing method to use.
   - `frule_f=frule`: function with an `frule`-like API that is tested (defaults to
     `frule`). Used for testing gradients from AD systems.
   - If `check_inferred=true`, then the inferrability (type-stability) of the `frule` is checked,
     as long as `f` is itself inferrable.
   - `fkwargs` are passed to `f` as keyword arguments.
- `testset_name`: if provided, the name of the testset used to wrap the tests.
  Otherwise it is determined from the function and argument types.
   - All remaining keyword arguments are passed to `isapprox`.
"""
function test_frule(args...; kwargs...)
    test_frule(TestConfig(), args...; kwargs...)
end

function test_frule(
    config::RuleConfig,
    f,
    args...;
    output_tangent=Auto(),
    fdm=_fdm,
    frule_f=ChainRulesCore.frule,
    check_inferred::Bool=true,
    fkwargs::NamedTuple=NamedTuple(),
    rtol::Real=1e-9,
    atol::Real=1e-9,
    testset_name=nothing,
    kwargs...,
)
    # To simplify some of the calls we make later lets group the kwargs for reuse
    isapprox_kwargs = (; rtol=rtol, atol=atol, kwargs...)
    testset_name = testset_name === nothing ? "test_frule: $f on $(_string_typeof(args))" : testset_name
    # and define a helper closure
    call_on_copy(f, xs...) = deepcopy(f)(deepcopy(xs)...; deepcopy(fkwargs)...)

    @testset "$(testset_name)" begin

        primals_and_tangents = auto_primal_and_tangent.((f, args...))
        primals = primal.(primals_and_tangents)
        tangents = tangent.(primals_and_tangents)

        if check_inferred && _is_inferrable(deepcopy(primals)...; deepcopy(fkwargs)...)
            _test_inferred(frule_f, deepcopy(config), deepcopy(tangents), deepcopy(primals)...; deepcopy(fkwargs)...)
        end

        res = call_on_copy(frule_f, config, tangents, primals...)
        res === nothing && throw(MethodError(frule_f, Tuple{Core.Typeof.(primals)...}))
        @test_msg "The frule should return (y, ∂y), not $res." res isa Tuple{Any,Any}
        Ω_ad, dΩ_ad = res
        Ω = call_on_copy(primals...)
        test_approx(Ω_ad, Ω; isapprox_kwargs...)

        # Correctness testing via finite differencing.
        is_ignored = isa.(tangents, NoTangent)
        dΩ_fd = _make_jvp_call(fdm, call_on_copy, Ω, primals, tangents, is_ignored)
        test_approx(dΩ_ad, dΩ_fd; isapprox_kwargs...)

        acc = output_tangent isa Auto ? rand_tangent(Ω) : output_tangent
        _test_add!!_behaviour(acc, dΩ_ad; isapprox_kwargs...)
    end  # top-level testset
end

"""
    test_rrule([config::RuleConfig,] f, args...; kwargs...)

# Arguments
- `config`: defaults to `ChainRulesTestUtils.TestConfig`.
- `f`: function for which the `rrule` should be tested. Its tangent can be provided using `f ⊢ f̄`.
  (You can enter `⊢` via `\\vdash` + tab in the Julia REPL and supporting editors.)
- `args...`: either the primal args `x`, or primals and their tangents: `x ⊢ x̄`
    - `x`: input at which to evaluate `f` (should generally be set to an arbitrary point in the domain).
    - `x̄`: currently accumulated cotangent; will be generated automatically if not provided.
    Non-differentiable arguments, such as indices, should have `x̄` set as `NoTangent()`.

# Keyword Arguments
 - `output_tangent`: the seed to propagate backward for testing (technically a cotangent).
   should be a differential for the output of `f`. Is set automatically if not provided.
 - `check_thunked_output_tangent=true`: also checks that passing a thunked version of the 
    output tangent to the pullback returns the same result.
 - `fdm::FiniteDifferenceMethod`: the finite differencing method to use.
 - `rrule_f=rrule`: function with an `rrule`-like API that is tested (defaults to `rrule`).
   Used for testing gradients from AD systems.
 - If `check_inferred=true`, then the inferrability (type-stability) of the `rrule` is checked
   — if `f` is itself inferrable — along with the inferrability of the pullback it returns.
 - `fkwargs` are passed to `f` as keyword arguments.
- `testset_name`: if provided, the name of the testset used to wrap the tests.
  Otherwise it is determined from the function and argument types.
 - All remaining keyword arguments are passed to `isapprox`.
"""
function test_rrule(args...; kwargs...)
    test_rrule(TestConfig(), args...; kwargs...)
end

function test_rrule(
    config::RuleConfig,
    f,
    args...;
    output_tangent=Auto(),
    check_thunked_output_tangent=true,
    fdm=_fdm,
    rrule_f=ChainRulesCore.rrule,
    check_inferred::Bool=true,
    fkwargs::NamedTuple=NamedTuple(),
    rtol::Real=1e-9,
    atol::Real=1e-9,
    testset_name=nothing,
    kwargs...,
)
    # To simplify some of the calls we make later lets group the kwargs for reuse
    isapprox_kwargs = (; rtol=rtol, atol=atol, kwargs...)
    testset_name = testset_name === nothing ? "test_rrule: $f on $(_string_typeof(args))" : testset_name
    # and define helper closure over fkwargs
    call(f, xs...) = f(xs...; fkwargs...)

    @testset "$(testset_name)" begin

        # Check correctness of evaluation.
        primals_and_tangents = auto_primal_and_tangent.((f, args...))
        primals = primal.(primals_and_tangents)
        accum_cotangents = tangent.(primals_and_tangents)

        if check_inferred && _is_inferrable(primals...; fkwargs...)
            _test_inferred(rrule_f, config, primals...; fkwargs...)
        end
        res = rrule_f(config, primals...; fkwargs...)
        res === nothing && throw(MethodError(rrule_f, Tuple{Core.Typeof.(primals)...}))
        y_ad, pullback = res
        y = call(primals...)
        test_approx(y_ad, y, "Failed primal value check"; isapprox_kwargs...)  # make sure primal is correct

        ȳ = output_tangent isa Auto ? rand_tangent(y) : output_tangent

        check_inferred && _test_inferred(pullback, ȳ)
        ad_cotangents = pullback(ȳ)
        @test_msg(
            "The pullback must return a Tuple (∂self, ∂args...)",
            ad_cotangents isa Tuple
        )
        @test_msg(
            "The pullback should return 1 cotangent for the primal and each primal input.",
            length(ad_cotangents) == length(primals)
        )

        # Correctness testing via finite differencing.
        is_ignored = isa.(accum_cotangents, NoTangent)
        fd_cotangents = _make_j′vp_call(fdm, call, ȳ, primals, is_ignored)
        msgs = ntuple(i->"cotangent for input $i, $(summary(fd_cotangents[i]))", length(fd_cotangents))
        foreach(accum_cotangents, ad_cotangents, fd_cotangents, msgs) do args...
            _test_cotangent(args...; check_inferred=check_inferred, isapprox_kwargs...)
        end

        if check_thunked_output_tangent
            test_approx(ad_cotangents, pullback(@thunk(ȳ)), "pulling back a thunk:"; isapprox_kwargs...)
            check_inferred && _test_inferred(pullback, @thunk(ȳ))
        end
    end  # top-level testset
end

"""
    @maybe_inferred [Type] f(...)

Like `@inferred`, but does not check the return type if tests are run as part of PkgEval or
if the environment variable `CHAINRULES_TEST_INFERRED` is set to `false`.
"""
macro maybe_inferred(ex...)
    inferred = Expr(:macrocall, GlobalRef(Test, Symbol("@inferred")), __source__, ex...)
    return :(TEST_INFERRED[] ? $(esc(inferred)) : $(esc(last(ex))))
end

"""
    _test_inferred(f, args...; kwargs...)

Simple wrapper for [`@maybe_inferred f(args...: kwargs...)`](@ref `@maybe_inferred`), avoiding the type-instability in not
knowing how many `kwargs` there are.
"""
function _test_inferred(f, args...; kwargs...)
    if isempty(kwargs)
        @maybe_inferred f(args...)
    else
        @maybe_inferred f(args...; kwargs...)
    end
end

"""
    _is_inferrable(f, args...; kwargs...) -> Bool

Return whether the return type of `f(args...; kwargs...)` is inferrable.
"""
function _is_inferrable(f, args...; kwargs...)
    try
        _test_inferred(f, args...; kwargs...)
        return true
    catch ErrorException
        return false
    end
end

"""
    _test_cotangent(accum_cotangent, ad_cotangent, fd_cotangent[, msg]; kwargs...)

Check if the cotangent `ad_cotangent` from `rrule` is consistent with `accum_tangent` and
approximately equal to the cotangent `fd_cotangent` obtained with finite differencing.

If `accum_cotangent` is `NoTangent()`, i.e., the argument was marked as non-differentiable,
`ad_cotangent` and `fd_cotangent` should be `NoTangent()` as well.

If a msg string is given, it is emmited on test failure.

# Keyword arguments
- If `check_inferred=true` (the default) and `ad_cotangent` is a thunk, then it is checked if
  its content can be inferred.
- All remaining keyword arguments are passed to `isapprox`.
"""
function _test_cotangent(
    accum_cotangent,
    ad_cotangent,
    fd_cotangent,
    msg="";
    check_inferred=true,
    kwargs...,
)
    ad_cotangent isa AbstractThunk && check_inferred && _test_inferred(unthunk, ad_cotangent)

    # The main test of the actual derivative being correct:
    test_approx(ad_cotangent, fd_cotangent, msg; kwargs...)
    _test_add!!_behaviour(accum_cotangent, ad_cotangent; kwargs...)
end

# we marked the argument as non-differentiable
function _test_cotangent(::NoTangent, ad_cotangent, ::NoTangent, msg=""; kwargs...)
    @test ad_cotangent isa NoTangent
end
function _test_cotangent(::NoTangent, ::ZeroTangent, ::NoTangent, msg=""; kwargs...)
    error(
        "The pullback in the rrule should use NoTangent()" *
        " rather than ZeroTangent() for non-perturbable arguments."
    )
end
function _test_cotangent(
    ::NoTangent,
    ad_cotangent::ChainRulesCore.NotImplemented,
    ::NoTangent,
    msg="";
    kwargs...,
)
    # this situation can occur if a cotangent is not implemented and
    # the default `rand_tangent` is `NoTangent`: e.g. due to having no fields
    # the `@test_broken` below should tell them that there is an easy implementation for
    # this case of `NoTangent()` (`@test_broken false` would be less useful!)
    # https://github.com/JuliaDiff/ChainRulesTestUtils.jl/issues/217
    @test_broken ad_cotangent isa NoTangent
end
function _test_cotangent(::NoTangent, ad_cotangent, fd_cotangent, msg=""; kwargs...)
    error("cotangent obtained with finite differencing has to be NoTangent()")
end

# For once you have the sensitivity by two methods (e.g  both finite-differencing and  AD)
# the code here checks it is correct.
# Goal is to only call `@isapprox` on things that render well
# Note that this must work well both on Differential types and Primal types

"""
    test_approx(actual, expected, [msg]; kwargs...)

`@test`'s  that `actual ≈ expected`, but breaks up data such that human readable results
are shown on failures.
Understands things like `unthunk`ing `ChainRuleCore.Thunk`s, etc.

If provided `msg` is printed on a failure. Often additional items are appended to `msg` to
give bread-crumbs into nested structures.

All keyword arguments are passed to `isapprox`.
"""
function test_approx(
    actual::Union{AbstractArray{<:Number},Number},
    expected::Union{AbstractArray{<:Number},Number},
    msg="";
    kwargs...,
)
    @test_msg msg isapprox(actual, expected; kwargs...)
end

for (T1, T2) in
    (
        (AbstractThunk, Any),
        (AbstractThunk, AbstractThunk),
        (Any, AbstractThunk),
        (Tangent, AbstractThunk),
        (AbstractThunk, Tangent),
        (AbstractZero, AbstractThunk),
        (AbstractThunk, AbstractZero),
    )
    @eval function test_approx(actual::$T1, expected::$T2, msg=""; kwargs...)
        return test_approx(unthunk(actual), unthunk(expected), msg; kwargs...)
    end
end

test_approx(::AbstractZero, x, msg=""; kwargs...) = test_approx(zero(x), x, msg; kwargs...)
test_approx(x, ::AbstractZero, msg=""; kwargs...) = test_approx(x, zero(x), msg; kwargs...)
test_approx(x::ZeroTangent, y::ZeroTangent, msg=""; kwargs...) = @test true
test_approx(x::NoTangent, y::NoTangent, msg=""; kwargs...) = @test true

function test_approx(z::AbstractZero, x::AbstractArray{<:AbstractArray}, msg=""; kwargs...)
    for el in x
        test_approx(el, z, msg; kwargs...)
    end
end
test_approx(x::AbstractArray{<:AbstractArray}, z::AbstractZero, msg=""; kwargs...) = test_approx(z, x, msg; kwargs...)

# remove once https://github.com/JuliaDiff/ChainRulesTestUtils.jl/issues/113
test_approx(x::NoTangent, y::Nothing, msg=""; kwargs...) = @test true
test_approx(x::Nothing, y::NoTangent, msg=""; kwargs...) = @test true

# Checking equality with `NotImplemented` reports `@test_broken` since the derivative has intentionally
# not yet been implemented
# `@test_broken x == y` yields more descriptive messages than `@test_broken false`
test_approx(x::ChainRulesCore.NotImplemented, y, msg=""; kwargs...) = @test_broken x == y
test_approx(x, y::ChainRulesCore.NotImplemented, msg=""; kwargs...) = @test_broken x == y
# In this case we check for equality (messages etc. have to be equal)
function test_approx(
    x::ChainRulesCore.NotImplemented, y::ChainRulesCore.NotImplemented, msg=""; kwargs...
)
    return @test_msg msg x == y
end

"""
    _can_pass_early(actual, expected; kwargs...)
Used to check if `actual` is basically equal to `expected`, so we don't need to check deeper
and can just report `test_approx` as passing.

If either `==` or `≈` return true then so does this.
The `kwargs` are passed on to `isapprox`
"""
function _can_pass_early(actual, expected; kwargs...)
    actual == expected && return true
    try
        return isapprox(actual, expected; kwargs...)
    catch err
        # Might MethodError, might DimensionMismatch, might fail for some other reason
        # we don't care, whatever errored it means we can't quit early
    end
    return false
end

function test_approx(actual::AbstractArray, expected::AbstractArray, msg=""; kwargs...)
    if _can_pass_early(actual, expected)
        @test true
    else
        @test_msg "$msg: indices must match" eachindex(actual) == eachindex(expected)
        for ii in eachindex(actual)
            new_msg = "$msg $(typeof(actual))[$ii]"
            test_approx(actual[ii], expected[ii], new_msg; kwargs...)
        end
    end
end

function test_approx(actual::Tangent{P}, expected::Tangent{P}, msg=""; kwargs...) where {P}
    if _can_pass_early(actual, expected)
        @test true
    else
        all_keys = union(keys(actual), keys(expected))
        for ii in all_keys
            new_msg = "$msg $P.$ii"
            test_approx(
                getproperty(actual, ii), getproperty(expected, ii), new_msg; kwargs...
            )
        end
    end
end

function test_approx(
    ::Tangent{ActualPrimal}, expected::Tangent{ExpectedPrimal}, msg=""; kwargs...
) where {ActualPrimal,ExpectedPrimal}
    # this will certainly fail as we have another dispatch for that, but this will give as
    # good error message
    @test ActualPrimal === ExpectedPrimal
end

# Some structual differential and a natural differential
function test_approx(actual::Tangent{P,T}, expected, msg=""; kwargs...) where {T,P}
    if _can_pass_early(actual, expected)
        @test true
    else
        @assert (T <: NamedTuple)  # it should be a structual differential if we hit this

        # We are only checking the properties that are in the Tangent
        # the natural differential is allowed to have other properties that we ignore
        for ii in propertynames(actual)
            new_msg = "$msg $P.$ii"
            test_approx(
                getproperty(actual, ii), getproperty(expected, ii), new_msg; kwargs...
            )
        end
    end
end
test_approx(x, y::Tangent, msg=""; kwargs...) = test_approx(y, x, msg; kwargs...)

test_approx(z::NoTangent, t::Tangent, msg=""; kwargs...) = @test all(==(NoTangent()), t)
test_approx(t::Tangent, z::NoTangent, msg=""; kwargs...) = @test all(==(NoTangent()), t)

# This catches comparisons of Tangents and Tuples/NamedTuple
# and gives an error message complaining about that. the `@test` will definitely fail
const LegacyZygoteCompTypes = Union{Tuple,NamedTuple}
function test_approx(x::Tangent, y::LegacyZygoteCompTypes, msg=""; kwargs...)
    @test_msg "$msg: for structural differentials use `Tangent`" typeof(x) === typeof(y)
end
function test_approx(x::LegacyZygoteCompTypes, y::Tangent, msg=""; kwargs...)
    return test_approx(y, x, msg; kwargs...)
end

# Generic fallback, probably a tuple or something
function test_approx(actual::A, expected::E, msg=""; kwargs...) where {A,E}
    if _can_pass_early(actual, expected)
        @test true
    else
        # Works around https://github.com/JuliaLang/julia/issues/43847 on pre-Julia v1.9
        c_actual = collect(Broadcast.materialize(actual))
        c_expected = collect(Broadcast.materialize(expected))
        if (c_actual isa A) && (c_expected isa E)  # prevent stack-overflow
            throw(MethodError, test_approx, (actual, expected))
        end
        test_approx(c_actual, c_expected, msg; kwargs...)
    end
end

###########################################################################################

"""
_test_add!!_behaviour(acc, val)

This checks that `acc + val` is the same as `add!!(acc, val)`.
It matters primarily for types that overload `add!!` such as `InplaceableThunk`s.

`acc` is the value that has been accumulated so far.
`val` is a deriviative, being accumulated into `acc`.

`kwargs` are all passed on to isapprox
"""
function _test_add!!_behaviour(acc, val; kwargs...)
    # Note, we don't test that `acc` is actually mutated because it doesn't have to be
    # e.g. if it is immutable. We do test the `add!!` return value.
    # That is what people should rely on. The mutation is just to save allocations.
    acc_mutated = deepcopy(acc)  # prevent this test changing others
    return test_approx(add!!(acc_mutated, val), acc + val, "in add!!"; kwargs...)
end

# Checking equality with `NotImplemented` reports `@test_broken` since the derivative has
# intentionally not yet been implemented
# `@test_broken x == y` yields more descriptive messages than `@test_broken false`
function _test_add!!_behaviour(acc_mutated, acc::ChainRulesCore.NotImplemented; kwargs...)
    return @test_broken acc_mutated == acc
end
function _test_add!!_behaviour(acc_mutated::ChainRulesCore.NotImplemented, acc; kwargs...)
    return @test_broken acc_mutated == acc
end
# In this case we check for equality (not implemented messages etc. have to be equal)
function _test_add!!_behaviour(
    acc_mutated::ChainRulesCore.NotImplemented,
    acc::ChainRulesCore.NotImplemented;
    kwargs...,
)
    return @test acc_mutated == acc
end

struct BadConstructor
    x
end

if VERSION >= v"1.3"
    @testset "global_checks.jl" begin
        test_method_tables()
        ChainRulesCore.rrule(::typeof(BadConstructor), x) = nothing
        @test fails(test_method_tables)
        Base.delete_method(Base.which(rrule, (DataType, Any)))
        test_method_tables()  # make sure delete worked

        ChainRulesCore.rrule(::RuleConfig, ::typeof(BadConstructor), x) = nothing
        @test fails(test_method_tables)
        Base.delete_method(Base.which(rrule, (RuleConfig, DataType, Any)))
        test_method_tables()  # make sure delete worked



        ChainRulesCore.frule(::Any, ::typeof(BadConstructor), x) = nothing
        @test fails(test_method_tables)
        Base.delete_method(Base.which(frule, (Any, DataType, Any)))
        test_method_tables()  # make sure delete worked

        ChainRulesCore.frule(::RuleConfig, ::Any, ::typeof(BadConstructor), x) = nothing
        @test fails(test_method_tables)
        Base.delete_method(Base.which(frule, (RuleConfig, Any, DataType, Any)))
        test_method_tables()  # make sure delete worked
    end
else # pre 1.3, so no `delete_method` so just test happy path
    @testset "global_checks.jl" begin
        test_method_tables()
    end
end

# Useful for LinearAlgebra tests
function generate_well_conditioned_matrix(rng::AbstractRNG, T, N)
    A = randn(rng, T, N, N)
    return A * A' + I
end

function generate_well_conditioned_matrix(rng::AbstractRNG, N)
    return generate_well_conditioned_matrix(rng, Float64, N)
end

generate_well_conditioned_matrix(N) = generate_well_conditioned_matrix(Random.GLOBAL_RNG, N)

function generate_well_conditioned_matrix(T, N)
    return generate_well_conditioned_matrix(Random.GLOBAL_RNG, T, N)
end

struct FakeNaturalDiffWithIsApprox  # For testing overloading isapprox(::Tangent) works:
    x
end
function Base.isapprox(c::Tangent, d::FakeNaturalDiffWithIsApprox; kwargs...)
    return isapprox(c.x, d.x, kwargs...)
end
function Base.isapprox(d::FakeNaturalDiffWithIsApprox, c::Tangent; kwargs...)
    return isapprox(c.x, d.x, kwargs...)
end

@testset "check_result.jl" begin
    @testset "_test_add!!_behaviour" begin
        check = ChainRulesTestUtils._test_add!!_behaviour

        check(10.0, 2.0)
        check(11.0, ZeroTangent())
        check([10.0, 20.0], @thunk([2.0, 0.0]))

        check(12.0, InplaceableThunk(X̄ -> error("Should not have in-placed"), @thunk(2.0)))

        check([10.0, 20.0], InplaceableThunk(X̄ -> (X̄[1] += 2.0; X̄), @thunk([2.0, 0.0])))
        @test fails() do
            check([10.0, 20.0], InplaceableThunk(X̄ -> (X̄[1] += 3.0; X̄), @thunk([2.0, 0.0])))
        end
    end

    @testset "test_approx" begin
        @testset "positive cases" begin
            test_approx(1.0, 1.0)
            test_approx(1.0 + im, 1.0 + im)
            test_approx(1.0, 1.0 + 1e-10)  # isapprox _behaviour
            test_approx((1.5, 2.5, 3.5), (1.5, 2.5, 3.5 + 1e-10))

            test_approx(ZeroTangent(), 0.0)

            test_approx([1.0, 2.0], [1.0, 2.0])
            test_approx([[1.0], [2.0]], [[1.0], [2.0]])
            test_approx([[0.0], [0.0]], ZeroTangent())
            test_approx(ZeroTangent(), [[0.0], [0.0]])
            test_approx(ZeroTangent(), [[0.0, 0.0], [[0.0, 0.0], [0.0, 0.0]]])
            test_approx([[0.0, 0.0], [[0.0, 0.0], [0.0, 0.0]]], NoTangent())
            test_approx(Broadcast.broadcasted(identity, [1.0 2.0; 3.0 4.0]), [1.0 2.0; 3.0 4.0])

            test_approx(@thunk(10 * 0.1 * [[1.0], [2.0]]), [[1.0], [2.0]])

            test_approx(@not_implemented(""), rand(3))
            test_approx(rand(3), @not_implemented(""))
            test_approx(@not_implemented("a"), @not_implemented("a"))

            test_approx(
                Tangent{Tuple{Float64,Float64}}(1.0, 2.0),
                Tangent{Tuple{Float64,Float64}}(1.0, 2.0),
            )

            diag_eg = Diagonal(randn(5))
            test_approx( # Structual == Structural
                Tangent{typeof(diag_eg)}(; diag=diag_eg.diag),
                Tangent{typeof(diag_eg)}(; diag=diag_eg.diag),
            )
            test_approx( # Structural == Natural
                Tangent{typeof(diag_eg)}(; diag=diag_eg.diag),
                diag_eg,
            )

            T = (a=1.0, b=2.0)
            test_approx(
                Tangent{typeof(T)}(; a=1.0), Tangent{typeof(T)}(; a=1.0, b=ZeroTangent())
            )
            test_approx(
                Tangent{typeof(T)}(; a=1.0),
                Tangent{typeof(T)}(; a=1.0 + 1e-10, b=ZeroTangent()),
            )

            test_approx(
                Tangent{FakeNaturalDiffWithIsApprox}(; x=1.4),
                FakeNaturalDiffWithIsApprox(1.4),
            )
            test_approx(
                FakeNaturalDiffWithIsApprox(1.4),
                Tangent{FakeNaturalDiffWithIsApprox}(; x=1.4),
            )

            # ambig with CRC after:
            # https://github.com/JuliaDiff/ChainRulesCore.jl/pull/524#issuecomment-1074037647
            test_approx(
                Tangent{Tuple{Float64,Float64}}(1.0, 2.0),
                @thunk(Tangent{Tuple{Float64,Float64}}(1.0, 2.0)),
            )
            test_approx(
                @thunk(Tangent{Tuple{Float64,Float64}}(1.0, 2.0)),
                Tangent{Tuple{Float64,Float64}}(1.0, 2.0),
            )
            test_approx(@thunk(ZeroTangent()), ZeroTangent())
            test_approx(ZeroTangent(), @thunk(ZeroTangent()))
            test_approx(
                Tangent{Tuple{Float64,Float64}}(NoTangent(), NoTangent()),
                NoTangent(),
            )
            test_approx(
                NoTangent(),
                Tangent{Tuple{Float64,Float64}}(NoTangent(), NoTangent()),
            )
        end
        @testset "negative case" begin
            @test fails(() -> test_approx(1.0, 2.0))
            @test fails(() -> test_approx(1.0 + im, 1.0 - im))
            @test fails(() -> test_approx((1.5, 2.5, 3.5), (1.5, 2.5, 4.5)))

            @test fails(() -> test_approx(ZeroTangent(), 20.0))
            @test fails(() -> test_approx(10.0, ZeroTangent()))

            @test fails(() -> test_approx([1.0, 2.0], [1.0, 3.9]))
            @test fails(() -> test_approx([[1.0], [2.0]], [[1.1], [2.0]]))
            @test fails(() -> test_approx([[0.0], [0.1]], ZeroTangent()))
            @test fails(() -> test_approx(ZeroTangent(), [[0.1], [0.0]]))
            @test fails(() -> test_approx([[0.0], [0.0], [[0.0, 0.1], [0.0]]], ZeroTangent()))
            @test fails(() -> test_approx(ZeroTangent(), [[0.0], [0.0], [[0.0, 0.1], [0.0]]]))

            @test fails(() -> test_approx(
                Tangent{Tuple{Float64,Float64}}(NoTangent(), 0.1),
                NoTangent(),
            ))
            @test fails(() -> test_approx(
                NoTangent(),
                Tangent{Tuple{Float64,Float64}}(NoTangent(), 0.1),
            ))

            @test fails(() -> test_approx(@thunk(10 * [[1.0], [2.0]]), [[1.0], [2.0]]))

            @test fails(() -> test_approx(@not_implemented("a"), @not_implemented("b")))

            # should fail, not ambig error
            @test fails() do 
                test_approx(
                    Tangent{Tuple{Float64,Float64}}(1.0, 2.0),
                    @thunk(Tangent{Tuple{Float64,Float64}}(2.0, 2.0)),
                )
            end
        end
        @testset "type negative" begin
            @test fails() do  # these have different primals so should not be equal
                test_approx(
                    Tangent{Tuple{Float32,Float32}}(1.0f0, 2.0f0),
                    Tangent{Tuple{Float64,Float64}}(1.0, 2.0),
                )
            end
            @test fails() do
                test_approx((1.0, 2.0), Tangent{Tuple{Float64,Float64}}(1.0, 2.0))
            end
        end

        @testset "TestIterator" begin
            data = randn(3)
            iter1 = TestIterator(data, Base.HasLength(), Base.HasEltype())
            iter2 = TestIterator(data, Base.HasLength(), Base.EltypeUnknown())
            test_approx(iter2, iter1)

            iter3 = TestIterator(data .+ 1e-10, Base.HasLength(), Base.HasEltype())
            test_approx(iter3, iter1)

            iter_bad = TestIterator(data .+ 010, Base.HasLength(), Base.HasEltype())
            @test fails(() -> test_approx(iter_bad, iter1))
        end
    end
end

"""
    rand_tangent([rng::AbstractRNG,] x)

Returns a arbitary tangent vector _appropriate_ for the primal value `x`.
Note that despite the name, no promises on the statistical randomness are made.
Rather it is an arbitary value, that is generated using the `rng`.
"""
rand_tangent(x) = rand_tangent(Random.GLOBAL_RNG, x)

# Try and make nice numbers with short decimal representations for good error messages
# while also not biasing the sample space too much
function rand_tangent(rng::AbstractRNG, x::T) where {T<:Number}
    # multiply by 9 to give a bigger range of values tested: no so tightly clustered around 0.
    return round(9 * randn(rng, T), digits=5, base=2)
end
rand_tangent(rng::AbstractRNG, x::Float64) = rand(rng, -9:0.01:9)
function rand_tangent(rng::AbstractRNG, x::ComplexF64)
    return ComplexF64(rand(rng, -9:0.1:9), rand(rng, -9:0.1:9))
end

# BigFloat/MPFR is finicky about short numbers, this doesn't always work as well as it should
# multiply by 9 to give a bigger range of values tested: no so tightly clustered around 0.
rand_tangent(rng::AbstractRNG, ::BigFloat) = round(big(9 * randn(rng)), digits=5, base=2)

rand_tangent(rng::AbstractRNG, x::AbstractArray) = ProjectTo(x)(rand_tangent.(Ref(rng), x))

rand_tangent(rng::AbstractRNG, x::Broadcast.Broadcasted) = rand_tangent(Broadcast.materialize(x))

function rand_tangent(rng::AbstractRNG, x::T) where {T}
    if !isstructtype(T)
        throw(ArgumentError("Non-struct types are not supported by this fallback."))
    end

    field_names = fieldnames(T)
    tangents = map(field_names) do field_name
        rand_tangent(rng, getfield(x, field_name))
    end
    if all(tangent isa NoTangent for tangent in tangents)
        # if none of my fields can be perturbed then I can't be perturbed
        return NoTangent()
    end

    if T <: Tuple
        return Tangent{T}(tangents...)
    else
        return Tangent{T}(; NamedTuple{field_names}(tangents)...)
    end
end

rand_tangent(rng::AbstractRNG, x::Symbol) = NoTangent()
rand_tangent(rng::AbstractRNG, x::AbstractChar) = NoTangent()
rand_tangent(rng::AbstractRNG, x::AbstractString) = NoTangent()
rand_tangent(rng::AbstractRNG, x::Integer) = NoTangent()
rand_tangent(rng::AbstractRNG, ::Ptr) = NoTangent()
rand_tangent(rng::AbstractRNG, ::Type) = NoTangent()
rand_tangent(rng::AbstractRNG, ::Module) = NoTangent()

# Test struct for `rand_tangent` and `difference`.
struct Bar
    a::Float64
    b::Int
    c::Any
 end
@testset "rand_tangent" begin
    rng = MersenneTwister(123456)

    @testset "Primal: $(typeof(x)), Tangent: $T_tangent" for (x, T_tangent) in [

        # Things without sensible tangents.
        ("hi", NoTangent),
        ('a', NoTangent),
        (:a, NoTangent),
        (true, NoTangent),
        (4, NoTangent),
        (FiniteDifferences, NoTangent),  # Module object
        # Types (not instances of type)
        (Bar, NoTangent),
        (Union{Int, Bar}, NoTangent),
        (Union{Int, Bar}, NoTangent),
        (Vector, NoTangent),
        (Vector{Float64}, NoTangent),
        (Integer, NoTangent),
        (Type{<:Real}, NoTangent),

        # Numbers.
        (5.0, Float64),
        (5.0 + 0.4im, Complex{Float64}),
        (big(5.0), BigFloat),

        # StridedArrays.
        (fill(randn(Float32)), Array{Float32, 0}),
        (fill(randn(Float64)), Array{Float64, 0}),
        (randn(Float32, 3), Vector{Float32}),
        (randn(Complex{Float64}, 2), Vector{Complex{Float64}}),
        (randn(5, 4), Matrix{Float64}),
        (randn(Complex{Float32}, 5, 4), Matrix{Complex{Float32}}),
        ([randn(5, 4), 4.0], Vector{Any}),

        # Co-Arrays
        (randn(5)', Adjoint{Float64, Vector{Float64}}),  # row-vector: special
        (randn(5, 4)', Matrix{Float64}),                 # matrix: generic dense

        (transpose(randn(5)), Transpose{Float64, Vector{Float64}}),  # row-vector: special
        (transpose(randn(5, 4)), Matrix{Float64}),                   # matrix: generic dense

        # AbstactArrays of non-perturbable types
        (1:10, NoTangent),
        (1:2:10, NoTangent),
        ([false, true], NoTangent),

        # Broadcasted.
        (Broadcast.broadcasted(sin, randn(5, 4)), Matrix{Float64}),

        # Tuples.
        ((4.0, ), Tangent{Tuple{Float64}}),
        ((5.0, randn(3)), Tangent{Tuple{Float64, Vector{Float64}}}),
        ((false, true), NoTangent),
        (Tuple{}(), NoTangent),

        # NamedTuples.
        ((a=4.0, ), Tangent{NamedTuple{(:a,), Tuple{Float64}}}),
        ((a=5.0, b=1), Tangent{NamedTuple{(:a, :b), Tuple{Float64, Int}}}),
        ((a=false, b=true), NoTangent),
        ((;), NoTangent),

        # structs.
        (Bar(5.0, 4, rand(rng, 3)), Tangent{Bar}),
        (Bar(4.0, 3, Bar(5.0, 2, 4)), Tangent{Bar}),
        (sin, NoTangent),
        # all fields NoTangent implies NoTangent
        (Pair(:a, "b"), NoTangent),
        (CartesianIndex(2, 3), NoTangent),

        # LinearAlgebra types
        (
            UpperTriangular(randn(3, 3)),
            UpperTriangular{Float64, Matrix{Float64}},
        ),
        (
            Diagonal(randn(2)),
            Diagonal{Float64, Vector{Float64}},
        ),
        (
            Symmetric(randn(2, 2)),
            Symmetric{Float64, Matrix{Float64}},
        ),
        (
            Hermitian(randn(ComplexF64, 1, 1)),
            Hermitian{ComplexF64, Matrix{ComplexF64}},
        ),
    ]
        @test rand_tangent(rng, x) isa T_tangent
        @test rand_tangent(x) isa T_tangent
    end

    @testset "erroring cases" begin
        # Ensure struct fallback errors for non-struct types.
        @test_throws ArgumentError invoke(rand_tangent, Tuple{AbstractRNG, Any}, rng, 5.0)
    end

    @testset "compsition of addition" begin
        x = Bar(1.5, 2, Bar(1.1, 3, [1.7, 1.4, 0.9]))
        @test x + rand_tangent(x) isa typeof(x)
        @test x + (rand_tangent(x) + rand_tangent(x)) isa typeof(x)
    end

    # Julia 1.6 changed to using Ryu printing algorithm and seems better at printing short
    VERSION >= v"1.6" && @testset "niceness of printing" begin
        rng = MersenneTwister(1)
        for i in 1:50
            @test length(string(rand_tangent(rng, 1.0))) <= 6
            @test length(string(rand_tangent(rng, 1.0 + 1.0im))) <= 12
            @test length(string(rand_tangent(rng, 1f0))) <= 9
            @test length(string(rand_tangent(rng, big"1.0"))) <= 9
        end
    end
end

# Defining test functions here as if they are defined where used it is too easy to
# mistakenly create closures over variables that only share names by coincidence.
futestkws(x; err=true) = err ? error("futestkws_err") : x

fbtestkws(x, y; err=true) = err ? error("fbtestkws_err") : x

sinconj(x) = sin(x)

primalapprox(x) = x

f_inferrable(x) = x
f_noninferrable_frule(x) = x
f_noninferrable_rrule(x) = x
f_noninferrable_pullback(x) = x
f_noninferrable_thunk(x, y) = x + y
f_inferrable_pullback_only(x) = x > 0 ? Float64(x) : Float32(x)

function finplace!(x; y=[1])
    y[1] = 2
    x .*= y[1]
    return x
end

struct Foo
    a::Float64
end
(f::Foo)(x) = return f.a + x
Base.length(::Foo) = 1
Base.iterate(f::Foo) = iterate(f.a)
Base.iterate(f::Foo, state) = iterate(f.a, state)

# constructor
function ChainRulesCore.rrule(::Type{Foo}, a)
    foo = Foo(a)
    function Foo_pullback(Δfoo)
        return NoTangent(), unthunk(Δfoo).a
    end
    return foo, Foo_pullback
end
function ChainRulesCore.frule((_, Δa), ::Type{Foo}, a)
    return Foo(a), Foo(Δa)
end

# functor
function ChainRulesCore.rrule(f::Foo, x)
    y = f(x)
    function Foo_pullback(Δy)
        return Tangent{Foo}(;a=Δy), Δy
    end
    return y, Foo_pullback
end
function ChainRulesCore.frule((Δf, Δx), f::Foo, x)
    return f(x), Δf.a + Δx
end

# Type-stable derivative for test below
struct FVecOfTuplesPullback{T} end
function (f::FVecOfTuplesPullback{T})(Δ) where {T}
    ΔΩ_first, ΔΩ_last = unthunk(Δ)
    Δx = map(z -> Tangent{T}(z, ΔΩ_last), ΔΩ_first)
    return NoTangent(), Δx
end

@testset "testers.jl" begin
    @testset "test_scalar" begin
        @testset "Ensure correct rules succeed" begin
            double(x) = 2x
            @scalar_rule(double(x), 2)
            test_scalar(double, 2.1)
        end
        @testset "Ensure incorrect rules caught" begin
            alt_double(x) = 2x
            @scalar_rule(alt_double(x), 3)  # this is wrong, on purpose
            @test fails(() -> test_scalar(alt_double, 2.1))
        end
    end

    @testset "unary: identity(x)" begin
        function ChainRulesCore.frule((_, ẏ), ::typeof(identity), x)
            return x, ẏ
        end
        function ChainRulesCore.rrule(::typeof(identity), x)
            function identity_pullback(ȳ)
                return (NoTangent(), ȳ)
            end
            return x, identity_pullback
        end
        @testset "test_frule" begin
            test_frule(identity, randn())
            test_frule(identity, randn(4))
        end
        @testset "test_rrule" begin
            test_rrule(identity, randn())
            test_rrule(identity, randn(4))
        end
    end

    @testset "Inplace accumulation: identity on Array" begin
        @testset "Correct definitions" begin
            local inplace_used
            function ChainRulesCore.frule((_, ẋ), ::typeof(identity), x::Array)
                ẏ = InplaceableThunk(ȧ -> (inplace_used = true; ȧ .+= ẋ), @thunk(ẋ))
                return identity(x), ẏ
            end
            function ChainRulesCore.rrule(::typeof(identity), x::Array)
                function identity_pullback(ȳ)
                    x̄_ret = InplaceableThunk(@thunk(ȳ)) do ā
                        inplace_used = true
                        ā .+= ȳ
                    end
                    return (NoTangent(), x̄_ret)
                end
                return identity(x), identity_pullback
            end

            inplace_used = false
            test_frule(identity, randn(4))
            @test inplace_used  # make sure we are using, and thus testing the add!

            inplace_used = false
            test_rrule(identity, randn(4))
            @test inplace_used  # make sure we are using, and thus testing the add!
        end

        @testset "Incorrect in-place definitions" begin
            my_identity(value) = value  # we will define bad rules on this
            function ChainRulesCore.frule((_, ẋ), ::typeof(my_identity), x::Array)
                # only the in-place part is incorrect
                ẏ = InplaceableThunk(ȧ -> ȧ .+= 200 .* ẋ, @thunk(ẋ))
                return my_identity(x), ẏ
            end
            function ChainRulesCore.rrule(::typeof(my_identity), x::Array)
                x_dims = size(x)
                function my_identity_pullback(ȳ)
                    # only the in-place part is incorrect
                    x̄_ret = InplaceableThunk(ā -> ā .+= 200 .* ȳ, @thunk(ȳ))
                    return (NoTangent(), x̄_ret)
                end
                return my_identity(x), my_identity_pullback
            end
            @test fails(() -> test_frule(my_identity, randn(4)))
            @test fails(() -> test_rrule(my_identity, randn(4)))
        end
    end

    @testset "check rules are inferrable" begin
        @testset "check inferred" begin
            ChainRulesCore.frule((_, Δx), ::typeof(f_inferrable), x) = (x, Δx)
            function ChainRulesCore.rrule(::typeof(f_inferrable), x)
                f_inferrable_pullback(Δy) = (NoTangent(), Δy)
                return x, f_inferrable_pullback
            end

            test_frule(f_inferrable, 2.0; check_inferred=false)
            test_frule(f_inferrable, 2.0)
            test_rrule(f_inferrable, 2.0; check_inferred=false)
            test_rrule(f_inferrable, 2.0)
            test_scalar(f_inferrable, 2.0)
            test_scalar(f_inferrable, 2.0; check_inferred=false)
        end

        @testset "check not inferred in frule" begin
            function ChainRulesCore.frule((_, Δx), ::typeof(f_noninferrable_frule), x)
                return (x, x > 0 ? Float64(Δx) : Float32(Δx))
            end
            function ChainRulesCore.rrule(::typeof(f_noninferrable_frule), x)
                f_noninferrable_frule_pullback(Δy) = (NoTangent(), Δy)
                return x, f_noninferrable_frule_pullback
            end

            test_frule(f_noninferrable_frule, 2.0; check_inferred=false)
            @test errors(
                () -> test_frule(f_noninferrable_frule, 2.0),
                "does not match inferred return type",
            )

            test_scalar(f_noninferrable_frule, 2.0; check_inferred=false)
            @test errors(
                () -> test_scalar(f_noninferrable_frule, 2.0),
                "does not match inferred return type",
            )
        end

        @testset "check not inferred in rrule" begin
            ChainRulesCore.frule((_, Δx), ::typeof(f_noninferrable_rrule), x) = (x, Δx)
            function ChainRulesCore.rrule(::typeof(f_noninferrable_rrule), x)
                if x > 0
                    f_noninferrable_rrule_pullback(Δy) = (NoTangent(), Δy)
                    return x, f_noninferrable_rrule_pullback
                else
                    return x, _ -> (NoTangent(), Δy) # this is not hit by the used point
                end
            end

            test_rrule(f_noninferrable_rrule, 2.0; check_inferred=false)
            @test errors(
                () -> test_rrule(f_noninferrable_rrule, 2.0),
                "does not match inferred return type",
            )

            test_scalar(f_noninferrable_rrule, 2.0; check_inferred=false)
            @test errors(
                () -> test_scalar(f_noninferrable_rrule, 2.0),
                "does not match inferred return type",
            )
        end

        @testset "check not inferred in pullback" begin
            function ChainRulesCore.rrule(::typeof(f_noninferrable_pullback), x)
                function f_noninferrable_pullback_pullback(Δy)
                    return (NoTangent(), (x > 0 ? Float64 : Float32)(unthunk(Δy)))
                end
                return x, f_noninferrable_pullback_pullback
            end
            test_rrule(f_noninferrable_pullback, 2.0; check_inferred=false)
            @test errors(
                () -> test_rrule(f_noninferrable_pullback, 2.0),
                "does not match inferred return type",
            )
        end

        @testset "check not inferred in thunk" begin
            function ChainRulesCore.rrule(::typeof(f_noninferrable_thunk), x, y)
                function f_noninferrable_thunk_pullback(Δz)
                    ∂x = @thunk(x > 0 ? Float64(unthunk(Δz)) : Float32(unthunk(Δz)))
                    return (NoTangent(), ∂x, Δz)
                end
                return x + y, f_noninferrable_thunk_pullback
            end
            test_rrule(f_noninferrable_thunk, 2.0, 3.0; check_inferred=false)
            @test errors(
                () -> test_rrule(f_noninferrable_thunk, 2.0, 3.0),
                "does not match inferred return type",
            )
        end

        @testset "check non-inferrable primal still passes if pullback inferrable" begin
            function ChainRulesCore.frule((_, Δx), ::typeof(f_inferrable_pullback_only), x)
                T  = x > 0 ? Float64 : Float32
                return T(x), T(Δx)
            end
            function ChainRulesCore.rrule(::typeof(f_inferrable_pullback_only), x)
                function f_inferrable_pullback_only_pullback(Δy)
                    return NoTangent(), oftype(x, unthunk(Δy))
                end
                return x > 0 ? Float64(x) : Float32(x), f_inferrable_pullback_only_pullback
            end
            test_frule(f_inferrable_pullback_only, 2.0; check_inferred=true)
            test_rrule(f_inferrable_pullback_only, 2.0; check_inferred=true)
        end
    end

    @testset "test derivative conjugated in pullback" begin
        ChainRulesCore.frule((_, Δx), ::typeof(sinconj), x) = (sin(x), cos(x) * Δx)

        # define rrule using ChainRulesCore's v0.9.0 convention, conjugating the derivative
        # in the rrule
        function ChainRulesCore.rrule(::typeof(sinconj), x)
            sinconj_pullback(ΔΩ) = (NoTangent(), conj(cos(x)) * ΔΩ)
            return sin(x), sinconj_pullback
        end

        test_rrule(sinconj, randn(ComplexF64))
        test_scalar(sinconj, randn(ComplexF64))
    end

    @testset "binary: fst(x, y)" begin
        fst(x, y) = x
        ChainRulesCore.frule((_, dx, dy), ::typeof(fst), x, y) = (x, dx)
        function ChainRulesCore.rrule(::typeof(fst), x, y)
            function fst_pullback(Δx)
                return (NoTangent(), Δx, ZeroTangent())
            end
            return x, fst_pullback
        end
        @testset "test_frule" begin
            test_frule(fst, 2.0, 3.0)
            test_frule(fst, randn(4), randn(4))
        end
        @testset "test_rrule" begin
            test_rrule(fst, 2.0, 4.0)
            test_rrule(fst, randn(4), randn(4))
        end
    end

    @testset "single input, multiple output" begin
        simo(x) = (x, 2x)
        function ChainRulesCore.rrule(::typeof(simo), x)
            simo_pullback((a, b)) = (NoTangent(), a .+ 2 .* b)
            return simo(x), simo_pullback
        end
        function ChainRulesCore.frule((_, ẋ), ::typeof(simo), x)
            y = simo(x)
            return y, Tangent{typeof(y)}(ẋ, 2ẋ)
        end

        @testset "test_frule" begin
            test_frule(simo, 1.5)  # on scalar
            test_frule(simo, randn(4))  # on array
        end
        @testset "test_rrule" begin
            test_rrule(simo, 3.0)  # on scalar
            test_rrule(simo, randn(4))  # on array
        end
    end

    @testset "tuple input: first" begin
        ChainRulesCore.frule((_, dx), ::typeof(first), xs::Tuple) = (first(xs), first(dx))
        function ChainRulesCore.rrule(::typeof(first), x::Tuple)
            function first_pullback(Δx)
                return (NoTangent(), Tangent{typeof(x)}(Δx, falses(length(x) - 1)...))
            end
            return first(x), first_pullback
        end

        @testset "test_frule" begin
            test_frule(first, (2.0, 3.0))
            test_frule(first, Tuple(randn(4)))
        end
        @testset "test_rrule" begin
            test_rrule(first, (2.0, 3.0); check_inferred=false)
            test_rrule(first, Tuple(randn(4)); check_inferred=false)
        end
    end

    @testset "tuple output (backing type of Tangent =/= natural differential)" begin
        tuple_out(x) = return (x, 1.0) # i.e. (x, 1.0) and not (x, x)
        function ChainRulesCore.frule((_, dx), ::typeof(tuple_out), x)
            Ω = tuple_out(x)
            ∂Ω = Tangent{typeof(Ω)}(dx, ZeroTangent())
            return Ω, ∂Ω
        end
        test_frule(tuple_out, 2.0)
    end

    @testset "ignoring arguments" begin
        fsymtest(x, s::Symbol) = x
        ChainRulesCore.frule((_, Δx, _), ::typeof(fsymtest), x, s) = (x, Δx)
        function ChainRulesCore.rrule(::typeof(fsymtest), x, s)
            function fsymtest_pullback(Δx)
                return NoTangent(), Δx, NoTangent()
            end
            return x, fsymtest_pullback
        end

        @testset "test_frule" begin
            test_frule(fsymtest, 2.5, :x)
        end

        @testset "test_rrule" begin
            test_rrule(fsymtest, 2.5, :x)
        end
    end

    @testset "unary with kwargs: futestkws(x; err)" begin
        function ChainRulesCore.frule((_, ẋ), ::typeof(futestkws), x; err=true)
            return futestkws(x; err=err), ẋ
        end
        function ChainRulesCore.rrule(::typeof(futestkws), x; err=true)
            function futestkws_pullback(Δx)
                return (NoTangent(), Δx)
            end
            return futestkws(x; err=err), futestkws_pullback
        end

        # we defined these functions at top of file to throw errors unless we pass `err=false`
        @test_throws ErrorException futestkws(randn())
        @test errors(() -> test_scalar(futestkws, randn()), "futestkws_err")
        @test_throws ErrorException frule((nothing, randn()), futestkws, randn())
        @test_throws ErrorException rrule(futestkws, randn())

        @test_throws ErrorException futestkws(randn(4))
        @test_throws ErrorException frule((nothing, randn(4)), futestkws, randn(4))
        @test_throws ErrorException rrule(futestkws, randn(4))

        @testset "scalar_test" begin
            test_scalar(futestkws, 2.5; fkwargs=(; err=false))
        end
        @testset "test_frule" begin
            test_frule(futestkws, 2.5; fkwargs=(; err=false))
            test_frule(futestkws, 2.5; fkwargs=(; err=false))
        end
        @testset "test_rrule" begin
            test_rrule(futestkws, 2.5; fkwargs=(; err=false))
            test_rrule(futestkws, 2.5; fkwargs=(; err=false))
        end
    end

    @testset "binary with kwargs: fbtestkws(x, y; err)" begin
        function ChainRulesCore.frule((_, ẋ, _), ::typeof(fbtestkws), x, y; err=true)
            return fbtestkws(x, y; err=err), ẋ
        end
        function ChainRulesCore.rrule(::typeof(fbtestkws), x, y; err=true)
            function fbtestkws_pullback(Δx)
                return (NoTangent(), Δx, ZeroTangent())
            end
            return fbtestkws(x, y; err=err), fbtestkws_pullback
        end

        # we defined these functions at top of file to throw errors unless we pass `err=false`
        @test_throws ErrorException fbtestkws(randn(), randn())
        @test_throws ErrorException frule(
            (nothing, randn(), nothing), fbtestkws, randn(), randn()
        )
        @test_throws ErrorException rrule(fbtestkws, randn(), randn())

        @test_throws ErrorException fbtestkws(randn(4), randn(4))
        @test_throws ErrorException frule(
            (nothing, randn(4), nothing), fbtestkws, randn(4), randn(4)
        )
        @test_throws ErrorException rrule(fbtestkws, randn(4), randn(4))

        @testset "test_frule" begin
            test_frule(fbtestkws, 2.5, 3.0; fkwargs=(; err=false))
            test_frule(fbtestkws, randn(4), randn(4); fkwargs=(; err=false))
        end
        @testset "test_rrule" begin
            test_rrule(fbtestkws, 2.5, 3.0; fkwargs=(; err=false))
            test_rrule(fbtestkws, randn(4), randn(4); fkwargs=(; err=false))
        end
    end

    @testset "primal can be only approximately equal" begin
        ChainRulesCore.frule((_, Δx), ::typeof(primalapprox), x) = (x + sqrt(eps(x)), Δx)

        function ChainRulesCore.rrule(::typeof(primalapprox), x)
            function primalapprox_pullback(Δx)
                return (NoTangent(), Δx)
            end
            return x + sqrt(eps(x)), primalapprox_pullback
        end

        test_frule(primalapprox, 2.5; atol=1e-6)
        test_rrule(primalapprox, 2.5; atol=1e-6)
    end

    @testset "frule with mutation" begin
        function ChainRulesCore.frule((_, ẋ), ::typeof(finplace!), x; y=[1])
            y[1] *= 2
            x .*= y[1]
            ẋ .*= 2 # hardcoded to match y defined below
            return x, ẋ
        end

        # these pass in tangents explictly so that we can check them after
        x = randn(3)
        ẋ = [4.0, 5.0, 6.0]
        xcopy, ẋcopy = copy(x), copy(ẋ)
        y = [1, 2]
        test_frule(finplace!, x ⊢ ẋ; fkwargs=(y=y,))
        @test x == xcopy
        @test ẋ == ẋcopy
        @test y == [1, 2]
    end

    @testset "TestIterator input" begin
        function iterfun(iter)
            state = iterate(iter)
            state === nothing && error()
            (x, i) = state
            s = x^2
            while true
                state = iterate(iter, i)
                state === nothing && break
                (x, i) = state
                s += x^2
            end
            return s
        end

        function ChainRulesCore.frule((_, Δiter), ::typeof(iterfun), iter)
            iter_Δiter = zip(iter, Δiter)
            state = iterate(iter_Δiter)
            state === nothing && error()
            # for some reason the following line errors if the frule is defined within a testset
            ((x, Δx), i) = state
            return iterfun(iter), sum(2 .* iter.data .* Δiter.data)
            s = x^2
            ∂s = 2 * x * Δx
            while true
                state = iterate(iter_Δiter, i)
                state === nothing && break
                ((x, Δx), i) = state
                s += x^2
                ∂s += 2 * x * Δx
            end
            return s, ∂s
        end

        function ChainRulesCore.rrule(::typeof(iterfun), iter::TestIterator)
            function iterfun_pullback(Δs)
                data = iter.data
                ∂data = (2 * Δs) .* conj.(data)
                ∂iter = TestIterator(
                    ∂data, Base.IteratorSize(iter), Base.IteratorEltype(iter)
                )
                return (NoTangent(), ∂iter)
            end
            return iterfun(iter), iterfun_pullback
        end

        @testset "Testing iterator function" begin
            # This needs to be in a separate testset to stop the `x` being shared with `iterfun`
            x = TestIterator(randn(2, 3), Base.SizeUnknown(), Base.EltypeUnknown())
            test_frule(iterfun, x)
            test_rrule(iterfun, x)
        end
    end

    @testset "unhappy path" begin
        @testset "primal wrong" begin
            my_identity1(x) = x
            function ChainRulesCore.frule((_, ẏ), ::typeof(my_identity1), x)
                return 2.5 * x, ẏ
            end
            function ChainRulesCore.rrule(::typeof(my_identity1), x)
                function identity_pullback(ȳ)
                    return (NoTangent(), ȳ)
                end
                return 2.5 * x, identity_pullback
            end

            @test fails(() -> test_frule(my_identity1, 2.2))
            @test fails(() -> test_rrule(my_identity1, 2.2))
        end

        @testset "derivative wrong" begin
            my_identity2(x) = x
            function ChainRulesCore.frule((_, ẏ), ::typeof(my_identity2), x)
                return x, 2.7 * ẏ
            end
            function ChainRulesCore.rrule(::typeof(my_identity2), x)
                function identity_pullback(ȳ)
                    return (NoTangent(), 31.8 * ȳ)
                end
                return x, identity_pullback
            end

            @test fails(() -> test_frule(my_identity2, 2.2))
            @test fails(() -> test_rrule(my_identity2, 2.2))
        end

        @testset "wrong number of outputs #167" begin
            foo(x, y) = x + 2y

            function ChainRulesCore.frule((_, ẋ, ẏ), ::typeof(foo), x, y)
                return foo(x, y), ẋ + 2ẏ, NoTangent() # extra derivative
            end

            function ChainRulesCore.rrule(::typeof(foo), x, y)
                foo_pullback(dz) = NoTangent(), dz # missing derivative
                return foo(x,y), foo_pullback
            end

            @test fails(() -> test_frule(foo, 2.1, 2.1))
            @test fails(() -> test_rrule(foo, 21.0, 32.0))
        end

        @testset "rrule not returning a tuple" begin
            bar(x, y) = x + 3y
            function ChainRulesCore.rrule(::typeof(bar), x, y)
                bar_pullback(dy) = dy
                return bar(x,y), bar_pullback
            end
            @test fails(() -> test_rrule(bar, 21.0, 32.0))
        end
    end

    @testset "structs" begin
        @testset "constructor" begin
            test_frule(Foo, rand())
            test_rrule(Foo, rand())
        end

        foo = Foo(rand())
        tfoo = Tangent{Foo}(;a=rand())
        @testset "functor" begin
            test_frule(foo, rand())
            test_rrule(foo, rand())
            test_scalar(foo, rand())

            test_frule(foo ⊢ Foo(rand()), rand())
            test_frule(foo ⊢ tfoo, rand())
            test_rrule(foo ⊢ Foo(rand()), rand())
            test_rrule(foo ⊢ tfoo, rand())
        end
    end


    @testset "Tuple primal that is not equal to differential backing" begin
        # https://github.com/JuliaMath/SpecialFunctions.jl/issues/288
        forwards_trouble(x) = (1, 2.0 * x)
        @scalar_rule(forwards_trouble(v), ZeroTangent(), 2.0)
        test_frule(forwards_trouble, 2.5)

        rev_trouble((x, y)) = y
        function ChainRulesCore.rrule(::typeof(rev_trouble), (x, y)::P) where {P}
            rev_trouble_pullback(ȳ) = (NoTangent(), Tangent{P}(ZeroTangent(), ȳ))
            return y, rev_trouble_pullback
        end
        test_rrule(rev_trouble, (3, 3.0) ⊢ Tangent{Tuple{Int,Float64}}(ZeroTangent(), 1.0))
    end

    @testset "check_thunked_output_tangent" begin
        @testset "no method for thunk" begin
            does_not_accept_thunk_id(x) = x
            function ChainRulesCore.rrule(::typeof(does_not_accept_thunk_id), x)
                does_not_accept_thunk_id_pullback(ȳ::AbstractArray) = (NoTangent() ,ȳ)
                return does_not_accept_thunk_id(x), does_not_accept_thunk_id_pullback
            end

            test_rrule(
                does_not_accept_thunk_id, [1.0, 2.0]; check_thunked_output_tangent=false
            )
            @test errors(r"MethodError.*Thunk") do
                test_rrule(does_not_accept_thunk_id, [1.0, 2.0])
            end
        end

        @testset "Thunk wrong" begin
            bad_thunk_id(x) = x
            function ChainRulesCore.rrule(::typeof(bad_thunk_id), x)
                bad_thunk_id_pullback(ȳ::AbstractArray) = (NoTangent(), ȳ)
                bad_thunk_id_pullback(ȳ::AbstractThunk) = (NoTangent(), 2 * ȳ)
                return bad_thunk_id(x), bad_thunk_id_pullback
            end

            test_rrule(bad_thunk_id, [1.0, 2.0]; check_thunked_output_tangent=false)
            @test fails(()->test_rrule(bad_thunk_id, [1.0, 2.0]))
        end
    end

    @testset "error message about incorrectly using ZeroTangent()" begin
        foo(a, i) = a[i]
        function ChainRulesCore.rrule(::typeof(foo), a, i)
            function foo_pullback(Δy)
                da = zeros(size(a))
                da[i] = Δy
                return NoTangent(), da, ZeroTangent()
            end
            return foo(a, i), foo_pullback
        end
        @test errors(() -> test_rrule(foo, [1.0, 2.0, 3.0], 2), "should use NoTangent()")
    end

    @testset "NotImplemented" begin
        f_notimplemented(x, y) = (x + y, x - y)
        @scalar_rule f_notimplemented(x, y) (@not_implemented(""), 1) (1, -1)
        test_frule(f_notimplemented, randn(), randn())
        test_rrule(f_notimplemented, randn(), randn())

        f_notimplemented2(f, x) = 2 * f(x)
        function ChainRulesCore.rrule(::typeof(f_notimplemented2), f::typeof(identity), x)
            Ω = f_notimplemented2(f, x)
            function f_notimplemented2_pullback(Ω̄)
                return NoTangent(), @not_implemented("TODO: implement this!"), 2 * Ω̄
            end
            return Ω, f_notimplemented2_pullback
        end
        test_rrule(f_notimplemented2, identity, randn())
    end

    @testset "@maybe_inferred" begin
        f_noninferrable(x) = Ref{Real}(x)[]

        @test @maybe_inferred(identity(1)) == 1
        @test errors("return type $Int does not match inferred return type Real") do
            @maybe_inferred f_noninferrable(1)
        end
        @test @maybe_inferred(Real, f_noninferrable(1)) == 1

        ChainRulesTestUtils.TEST_INFERRED[] = false

        @test @maybe_inferred(identity(1)) == 1
        @test @maybe_inferred(f_noninferrable(1)) == 1
        @test @maybe_inferred(Real, f_noninferrable(1)) == 1

        ChainRulesTestUtils.TEST_INFERRED[] = true
    end

    @testset "inference of thunked cotangents" begin
        my_id(x) = x
        function ChainRulesCore.rrule(::typeof(my_id), x)
            my_id_pb(ȳ) = (NoTangent(), ȳ)
            function my_id_pb(ȳ::AbstractThunk)
                # We use a condition that always evaluates to true to avoid issues with tolerances
                # (see https://github.com/JuliaDiff/ChainRulesTestUtils.jl/pull/247)
                # The function is type unstable for `Float64` inputs nevertheless
                precision = rand() >= 0.0 ? Float64 : Float32
                return (NoTangent(), precision(unthunk(ȳ)))
            end
            return x, my_id_pb
        end

        @test errors(() -> test_rrule(my_id, 2.0))
        test_rrule(my_id, 2.0; check_inferred=false)
        test_rrule(my_id, 2.0; check_thunked_output_tangent=false)
    end

    # https://github.com/JuliaDiff/ChainRulesTestUtils.jl/pull/224
    @testset "vectors of tuples" begin
        function f_vec_of_tuples(x::AbstractVector{<:Tuple{<:Any,<:Any}})
            return map(first, x), sum(last, x)
        end
        function ChainRulesCore.frule(
            (_, Δx),
            ::typeof(f_vec_of_tuples),
            x::AbstractVector{<:Tuple{<:Any,<:Any}},
        )
            Ω = f_vec_of_tuples(x)
            Ω̄ = Tangent{typeof(Ω)}(f_vec_of_tuples(map(ChainRulesCore.backing, Δx))...)
            return Ω, Ω̄
        end
        function ChainRulesCore.rrule(
            ::typeof(f_vec_of_tuples),
            x::AbstractVector{<:Tuple{<:Any,<:Any}},
        )
            Ω = f_vec_of_tuples(x)
            # We use a functor here to fix type inference
            f_vec_of_tuples_pullback = FVecOfTuplesPullback{eltype(x)}()
            return Ω, f_vec_of_tuples_pullback
        end

        x_tuples = [(1.0, 2.0), (3.0, 4.0), (5.0, 6.0)]
        test_frule(f_vec_of_tuples, x_tuples)
        test_rrule(f_vec_of_tuples, x_tuples)
    end
    @testset "check passing of testset_name kwarg" begin
        name = "my test name"
        double(x) = 2x
        @scalar_rule(double(x), 2)
        x = test_scalar(double, 2.1; testset_name=name)
        @test x.description == name
        x = test_frule(identity, 1.0; testset_name=name)
        @test x.description == name
        x = test_rrule(identity, 1.0; testset_name=name)
        @test x.description == name
    end
end

# For testing this config uses finite differences to evaluate the frule and rrule
struct TestConfig <: RuleConfig{Union{HasReverseMode, HasForwardsMode}}
    fdm
end
TestConfig() = TestConfig(central_fdm(5, 1))

function ChainRulesCore.frule_via_ad(config::TestConfig, ȧrgs, f, args...; kws...)

    # try using a rule
    ret = frule(config, ȧrgs, f, args...; kws...)
    ret === nothing || return ret

    # but if the rule doesn't exist, use finite differencing instead
    call_on_copy(f, xs...) = deepcopy(f)(deepcopy(xs)...; deepcopy(kws)...)

    primals = (f, args...)
    is_ignored = isa.(ȧrgs, NoTangent)

    Ω = call_on_copy(f, args...)
    ΔΩ = _make_jvp_call(config.fdm, call_on_copy, Ω, primals, ȧrgs, is_ignored)

    return Ω, ΔΩ
end

function ChainRulesCore.rrule_via_ad(config::TestConfig, f, args...; kws...)

    # try using a rule
    ret = rrule(config, f, args...; kws...)
    ret === nothing || return ret

    # but if the rule doesn't exist, use finite differencing instead
    call(f, xs...) = f(xs...; kws...)

    # this block is here just to work out which tangents should be ignored
    primals = (f, args...)
    primals_and_tangents = auto_primal_and_tangent.(primals)
    is_ignored = isa.(tangent.(primals_and_tangents), NoTangent)

    function f_pb(ȳ)
        return _make_j′vp_call(config.fdm, call, ȳ, primals, is_ignored)
    end

    return call(f, args...), f_pb
end

"""
    Auto()

Use this in the place of a tangent/cotangent in [`test_frule`](@ref) or
[`test_rrule`](@ref) to have that tangent/cotangent generated automatically based on the
primal. Uses `FiniteDifferences.rand_tangent`.
"""
struct Auto end

"""
    PrimalAndTangent

A struct that represents a primal value paired with its tangent or cotangent.
For conciseness we refer to both tangent and cotangent as "tangent".
"""
struct PrimalAndTangent{P,D}
    primal::P
    tangent::D
end
primal(p::PrimalAndTangent) = p.primal
tangent(p::PrimalAndTangent) = p.tangent

"""
    primal ⊢ tangent

Infix shorthand method to construct a `PrimalAndTangent`.
Enter via `\\vdash` + tab on supporting editors.
"""
const ⊢ = PrimalAndTangent

"""
    auto_primal_and_tangent(primal; rng=Random.GLOBAL_RNG)
    auto_primal_and_tangent(::PrimalAndTangent; rng=Random.GLOBAL_RNG)

Convience constructor for `PrimalAndTangent` where the primal is provided

This function is idempotent. If you pass it a `PrimalAndTangent` it doesn't change it.
"""
auto_primal_and_tangent(primal; rng=Random.GLOBAL_RNG) = primal ⊢ rand_tangent(rng, primal)
auto_primal_and_tangent(both::PrimalAndTangent; kwargs...) = both

@testset "Data Generation" begin
    function _is_well_conditioned(matrix)
        @test !isempty(matrix)
        @test isposdef(matrix)
        @assert length(matrix) ≤ 25
        @test cond(matrix) < 100
    end

    @testset "Generate Well Conditioned Matrix" begin
        rng = MersenneTwister(1)
        @testset "Pass in RNG" begin
            matrix = generate_well_conditioned_matrix(rng, 5)
            _is_well_conditioned(matrix)
            @testset "$T" for T in (Float64, ComplexF64)
                matrix = generate_well_conditioned_matrix(rng, T, 5)
                _is_well_conditioned(matrix)
            end
        end

        @testset "Global RNG" begin
            matrix = generate_well_conditioned_matrix(5)
            _is_well_conditioned(matrix)
            @testset "$T" for T in (Float64, ComplexF64)
                matrix = generate_well_conditioned_matrix(T, 5)
            end
        end
    end
end

# testing configs
abstract type MySpecialTrait end
struct MySpecialConfig <: RuleConfig{Union{MySpecialTrait}} end

@testset "rule_config.jl" begin
    @testset "custom rrule_f" begin
        only2x(x, y) = 2x
        custom(::RuleConfig, ::typeof(only2x), x, y) = only2x(x, y), Δ -> (NoTangent(), 2Δ, ZeroTangent())
        wrong1(::RuleConfig, ::typeof(only2x), x, y) = only2x(x, y), Δ -> (ZeroTangent(), 2Δ, ZeroTangent())
        wrong2(::RuleConfig, ::typeof(only2x), x, y) = only2x(x, y), Δ -> (NoTangent(), 2.1Δ, ZeroTangent())
        wrong3(::RuleConfig, ::typeof(only2x), x, y) = only2x(x, y), Δ -> (NoTangent(), 2Δ)

        test_rrule(only2x, 2.0, 3.0; rrule_f=custom, check_inferred=false)
        @test errors(() -> test_rrule(only2x, 2.0, 3.0; rrule_f=wrong1, check_inferred=false))
        @test fails(() -> test_rrule(only2x, 2.0, 3.0; rrule_f=wrong2, check_inferred=false))
        @test fails(() -> test_rrule(only2x, 2.0, 3.0; rrule_f=wrong3, check_inferred=false))
    end

    @testset "custom frule_f" begin
        mytuple(x, y) = return 2x, 1.0
        T = Tuple{Float64, Float64}
        custom(::RuleConfig, (Δf, Δx, Δy), ::typeof(mytuple), x, y) = mytuple(x, y), Tangent{T}(2Δx, ZeroTangent())
        wrong1(::RuleConfig, (Δf, Δx, Δy), ::typeof(mytuple), x, y) = mytuple(x, y), Tangent{T}(2.1Δx, ZeroTangent())
        wrong2(::RuleConfig, (Δf, Δx, Δy), ::typeof(mytuple), x, y) = mytuple(x, y), Tangent{T}(2Δx, 1.0)

        test_frule(mytuple, 2.0, 3.0; frule_f=custom, check_inferred=false)
        @test fails(() -> test_frule(mytuple, 2.0, 3.0; frule_f=wrong1, check_inferred=false))
        @test fails(() -> test_frule(mytuple, 2.0, 3.0; frule_f=wrong2, check_inferred=false))
    end

    @testset "custom_config" begin
        has_config(x) = 2x
        function ChainRulesCore.rrule(::MySpecialConfig, ::typeof(has_config), x)
            has_config_pullback(ȳ) = return (NoTangent(), 2ȳ)
            return has_config(x), has_config_pullback
        end

        has_trait(x) = 2x
        function ChainRulesCore.rrule(::RuleConfig{<:MySpecialTrait}, ::typeof(has_trait), x)
            has_trait_pullback(ȳ) = return (NoTangent(), 2ȳ)
            return has_trait(x), has_trait_pullback
        end

        # it works if the special config is provided
        test_rrule(MySpecialConfig(), has_config, rand())
        test_rrule(MySpecialConfig(), has_trait, rand())

        # but it doesn't work for the default config
        errors(() -> test_rrule(has_config, rand()), "no method matching rrule")
        errors(() -> test_rrule(has_trait, rand()), "no method matching rrule")
    end

    @testset "TestConfig direct" begin
        poly(x) = x^2 + 3.2x

        x = 2.1
        config = ChainRulesTestUtils.TestConfig()

        @testset "rrule" begin
            y, pb = rrule_via_ad(config, poly, x)
            @test y == poly(x)
            test_approx(pb(1.0), (NoTangent(), (2*x + 3.2) * 1.0))
            # and automatically
            test_rrule(config, poly, rand(); rrule_f=rrule_via_ad, check_inferred=false)
        end

        @testset "frule" begin
            ḟ, ẋ = (NoTangent(), rand())
            Ω, ΔΩ = frule_via_ad(config, (ḟ, ẋ), poly, x)
            @test Ω == poly(x)
            test_approx(ΔΩ, (2*x + 3.2) * ẋ)
            # and automatically
            test_frule(config, poly, x; frule_f=frule_via_ad, check_inferred=false)
        end

        # more functions
        simo(x) = (x, 2x, 3x)
        miso(x, y, z) = x+y
        test_rrule(config, simo, x; rrule_f=rrule_via_ad, check_inferred=false)
        test_rrule(config, miso, x, 2x, "s"; rrule_f=rrule_via_ad, check_inferred=false)

        test_frule(config, simo, x; frule_f=frule_via_ad, check_inferred=false)
        test_frule(config, miso, x, x, "s"; frule_f=frule_via_ad, check_inferred=false)
    end

    @testset "TestConfig in a rule" begin
        inner(x, y) = x^2 + 2*y + 3
        outer(f, x) = 2 * f(x, 3.2)

        function ChainRulesCore.rrule(config::RuleConfig{>:HasReverseMode}, ::typeof(outer), f, x)
            fx, pb_f = rrule_via_ad(config, f, x, 3.2)
            outer_pb(ȳ) = (NoTangent(), pb_f(2 * ȳ)[1:2]...)
            return outer(f, x), outer_pb
        end

        function ChainRulesCore.frule(config::RuleConfig{>:HasForwardsMode}, (ȯuter, ḟ, ẋ), ::typeof(outer), f, x)
            inner, inner_dot = frule_via_ad(config, (ḟ, ẋ, NoTangent()), f, x, 3.2)
            return 2 * inner, 2 * inner_dot
        end

        config = ChainRulesTestUtils.TestConfig()
        test_rrule(config, outer, inner, rand(); rrule_f=rrule_via_ad, check_inferred=false)
        test_frule(config, outer, inner, rand(); frule_f=frule_via_ad, check_inferred=false)
    end

    @testset "Catch incorrect rules" begin
        myid(x) = x
        function ChainRulesCore.rrule(config::RuleConfig{>:HasReverseMode}, ::typeof(myid), x)
            wrong_pb(dy) = (NoTangent(), 8dy)
            return x, wrong_pb
        end
        @test fails(() -> test_rrule(myid, 3.0; rrule_f=rrule_via_ad, check_inferred=false))
    end
end

"""
    TestIterator{T,IS<:Base.IteratorSize,IE<:Base.IteratorEltype}

A configurable iterator for testing purposes.

    TestIterator(data, itersize, itereltype)
    TestIterator(data)

The iterator wraps another iterator `data`, such as an array, that must have at least as
many features implemented as the test iterator and have a `FiniteDifferences.to_vec`
overload. By default, the iterator it has the same features as `data`.

The optional methods `eltype`, `length`, and `size` are automatically defined and forwarded
to `data` if the type arguments indicate that they should be defined.
"""
struct TestIterator{T,IS,IE}
    data::T
end
function TestIterator(data, itersize::Base.IteratorSize, itereltype::Base.IteratorEltype)
    return TestIterator{typeof(data),typeof(itersize),typeof(itereltype)}(data)
end
TestIterator(data) = TestIterator(data, Base.IteratorSize(data), Base.IteratorEltype(data))

Base.iterate(iter::TestIterator) = iterate(iter.data)
Base.iterate(iter::TestIterator, state) = iterate(iter.data, state)

Base.IteratorSize(::Type{<:TestIterator{<:Any,IS}}) where {IS} = IS()

Base.IteratorEltype(::Type{<:TestIterator{<:Any,<:Any,IE}}) where {IE} = IE()

Base.eltype(::Type{<:TestIterator{T,<:Any,Base.HasEltype}}) where {T} = eltype(T)

Base.length(iter::TestIterator{<:Any,Base.HasLength}) = length(iter.data)
Base.length(iter::TestIterator{<:Any,<:Base.HasShape}) = length(iter.data)

Base.size(iter::TestIterator{<:Any,<:Base.HasShape}) = size(iter.data)

Base.:(==)(iter1::T, iter2::T) where {T<:TestIterator} = iter1.data == iter2.data

Base.isequal(iter1::T, iter2::T) where {T<:TestIterator} = isequal(iter1.data, iter2.data)

function Base.hash(iter::TestIterator{<:Any,IT,IS}) where {IT,IS}
    return mapreduce(hash, hash, (iter.data, IT, IS))
end

# To make it a valid differential: needs at very least `zero` and `+`
Base.zero(::Type{<:TestIterator}) = ZeroTangent()
function Base.:+(iter1::TestIterator{T,IS,IE}, iter2::TestIterator{T,IS,IE}) where {T,IS,IE}
    return TestIterator{T,IS,IE}(map(+, iter1.data, iter2.data))
end

# For testing purposes:

function rand_tangent(rng::AbstractRNG, x::TestIterator{<:Any,IS,IE}) where {IS,IE}
    ∂data = rand_tangent(rng, x.data)
    return TestIterator{typeof(∂data),IS,IE}(∂data)
end

function FiniteDifferences.to_vec(iter::TestIterator)
    iter_vec, back = to_vec(iter.data)
    function TestIterator_from_vec(v)
        return TestIterator(back(v), Base.IteratorSize(iter), Base.IteratorEltype(iter))
    end
    return iter_vec, TestIterator_from_vec
end

const _fdm = central_fdm(5, 1; max_range=1e-2)
const TEST_INFERRED = Ref(true)
const TRANSFORMS_TO_ALT_TANGENTS = Function[x->@thunk(x)] # e.g. [_ -> ZeroTangent(), x -> rebasis(x)]

"sets up TEST_INFERRED based ion enviroment variables"
function init_test_inferred_setting!()
    TEST_INFERRED[] = if haskey(ENV, "CHAINRULES_TEST_INFERRED")
        parse(Bool, "CHAINRULES_TEST_INFERRED")
    else
        !parse(Bool, get(ENV, "JULIA_PKGEVAL", "false"))
    end

    !TEST_INFERRED[] && @warn "inference tests have been disabled"
end

@testset "TestIterator" begin
    @testset "Constructors" begin
        data = randn(3)
        iter = TestIterator(data)
        @test iter isa TestIterator{
            typeof(data),typeof(Base.IteratorSize(data)),typeof(Base.IteratorEltype(data))
        }
        @test iter.data === data

        data = randn(2, 3, 4)
        iter = TestIterator(data)
        @test iter isa TestIterator{
            typeof(data),typeof(Base.IteratorSize(data)),typeof(Base.IteratorEltype(data))
        }
        @test iter.data === data

        data = randn(2, 3, 4)
        iter = TestIterator(data, Base.SizeUnknown(), Base.EltypeUnknown())
        @test iter isa TestIterator{typeof(data),Base.SizeUnknown,Base.EltypeUnknown}
    end

    @testset "iterate" begin
        data = randn(3)
        iter = TestIterator(data)

        @test iterate(iter) === iterate(data)
        _, state = iterate(data)
        @test iterate(iter, state) === iterate(data, state)
    end

    @testset "optional interface methods" begin
        data = randn(2, 3, 4)
        iter = TestIterator(data)
        @test eltype(iter) === eltype(data)
        @test length(iter) === length(data)
        @test size(iter) === size(data)

        iter = TestIterator(data, Base.HasLength(), Base.HasEltype())
        @test length(iter) === length(data)
        @test_throws MethodError size(iter)
        @test eltype(iter) === eltype(iter)

        iter = TestIterator(data, Base.SizeUnknown(), Base.EltypeUnknown())
        @test_throws MethodError length(iter)
        @test eltype(iter) === Any
    end

    @testset "==" begin
        data = randn(2, 3, 4)
        iter1 = TestIterator(data, Base.HasLength(), Base.HasEltype())
        iter2 = TestIterator(data, Base.HasLength(), Base.EltypeUnknown())
        @test iter2 != iter1

        iter3 = TestIterator(copy(data), Base.HasLength(), Base.HasEltype())
        @test iter3 == iter1
    end

    @testset "isequal" begin
        data = randn(2, 3, 4)
        iter1 = TestIterator(data, Base.HasLength(), Base.HasEltype())
        iter2 = TestIterator(data, Base.HasLength(), Base.EltypeUnknown())
        @test !isequal(iter2, iter1)

        iter3 = TestIterator(copy(data), Base.HasLength(), Base.HasEltype())
        @test isequal(iter3, iter1)
    end

    @testset "hash" begin
        data = randn(2, 3, 4)
        iter1 = TestIterator(data, Base.HasLength(), Base.HasEltype())
        iter2 = TestIterator(data, Base.HasLength(), Base.EltypeUnknown())
        @test hash(iter2) != hash(iter1)

        iter3 = TestIterator(copy(data), Base.HasLength(), Base.HasEltype())
        @test hash(iter3) == hash(iter1)
    end

    @testset "to_vec" begin
        data = randn(2, 3, 4)
        iter = TestIterator(data, Base.SizeUnknown(), Base.EltypeUnknown())
        v, back = ChainRulesTestUtils.to_vec(iter)
        @test v isa AbstractVector{eltype(data)}
        @test collect(v) == collect(vec(data))
        iter2 = back(v)
        @test iter2 == iter
    end

    @testset "rand_tangent" begin
        data = randn(2, 3, 4)
        iter = TestIterator(data, Base.SizeUnknown(), Base.EltypeUnknown())
        ∂iter = rand_tangent(iter)
        @test ∂iter isa typeof(iter)
        @test size(∂iter.data) == size(iter.data)
        @test eltype(∂iter.data) === eltype(iter.data)
    end
end

using ChainRulesTestUtils
using Documenter

makedocs(;
    modules=[ChainRulesTestUtils],
    format=Documenter.HTML(; prettyurls=false, assets=["assets/chainrules.css"]),
    sitename="ChainRulesTestUtils",
    authors="JuliaDiff contributors",
    pages=[
        "ChainRulesTestUtils" => "index.md",
        "API" => "api.md",
    ],
    checkdocs=:exports,
    # doctest=:fix
   )

const repo = "github.com/JuliaDiff/ChainRulesTestUtils.jl.git"
deploydocs(; repo=repo, push_preview=true)

```@meta
DocTestFilters = [r"[0-9\.]+s",r"isapprox\(.*\)"]
```
# ChainRulesTestUtils

[![CI](https://github.com/JuliaDiff/ChainRulesTestUtils.jl/workflows/CI/badge.svg?branch=main)](https://github.com/JuliaDiff/ChainRulesTestUtils.jl/actions?query=workflow%3ACI)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)


[ChainRulesTestUtils.jl](https://github.com/JuliaDiff/ChainRulesTestUtils.jl) helps you test [`ChainRulesCore.frule`](http://www.juliadiff.org/ChainRulesCore.jl/dev/api.html) and [`ChainRulesCore.rrule`](http://www.juliadiff.org/ChainRulesCore.jl/dev/api.html) methods, when adding rules for your functions in your own packages.
For information about ChainRules, including how to write rules, refer to the general ChainRules Documentation:
[![](https://img.shields.io/badge/docs-main-blue.svg)](https://JuliaDiff.github.io/ChainRulesCore.jl/dev)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaDiff.github.io/ChainRulesCore.jl/stable)

## Testing Method Table Sensibility
A basic feature of ChainRulesTestUtils is its ability to check that the method tables for `rrule` and `frule` remain sensible.
This searches the method tables for methods that should not exist and when it fails tells you where they were defined.
By calling [`test_method_tables`](@ref) ChainRulesTestUtils will check for things such as having attracted a rule to `DataType` rather than attaching it to a constructor.
Basically all packages using ChainRulesTestUtils can use [`test_method_tables`](@ref), as it is independent of what rules you have written.

## Canonical example of testing frule and rrule

Let's suppose a custom transformation has been defined
```jldoctest ex
function two2three(x1::Float64, x2::Float64)
    return 1.0, 2.0*x1, 3.0*x2
end

# output
two2three (generic function with 1 method)
```
along with the `frule`
```jldoctest ex
using ChainRulesCore

function ChainRulesCore.frule((Δf, Δx1, Δx2), ::typeof(two2three), x1, x2)
    y = two2three(x1, x2)
    ∂y = Tangent{Tuple{Float64, Float64, Float64}}(ZeroTangent(), 2.0*Δx1, 3.0*Δx2)
    return y, ∂y
end
# output

```
and `rrule` which contains a mistake in the first cotangent
```jldoctest ex
function ChainRulesCore.rrule(::typeof(two2three), x1, x2)
    y = two2three(x1, x2)
    function two2three_pullback(Ȳ)
        return (NoTangent(), 2.1*Ȳ[2], 3.0*Ȳ[3])
    end
    return y, two2three_pullback
end
# output

```

The [`test_frule`](@ref)/[`test_rrule`](@ref) helper function compares the `frule`/`rrule` outputs
to the gradients obtained by finite differencing.
They can be used for any type and number of inputs and outputs.

### Testing the `frule`

[`test_frule`](@ref) takes in the function `f` and the primal input `x`.
The call will test the `frule` for function `f` at the point `x` in the domain.
Keep this in mind when testing discontinuous rules for functions like [ReLU](https://en.wikipedia.org/wiki/Rectifier_(neural_networks)), which should ideally be tested at both `x` being above and below zero.

```jldoctest ex
julia> using ChainRulesTestUtils;

julia> test_frule(two2three, 3.33, -7.77);
Test Summary:                            | Pass  Total  Time
test_frule: two2three on Float64,Float64 |    6      6  2.7s

```

### Testing the `rrule`

[`test_rrule`](@ref) takes in the function `f`, and primal inputs `x`.
The call will test the `rrule` for function `f` at the point `x`, and similarly to `frule` some rules should be tested at multiple points in the domain.

```jldoctest ex
julia> test_rrule(two2three, 3.33, -7.77);
test_rrule: two2three on Float64,Float64: Test Failed at /home/lior/.julia/dev/ChainRulesTestUtils/src/check_result.jl:24
  Expression: isapprox(actual, expected; kwargs...)
  Problem: cotangent for input 2, Float64
   Evaluated: isapprox(-4.032, -3.840000000001641; rtol = 1.0e-9, atol = 1.0e-9)
[...]
```

The output of the test indicates to us the cause of the failure under "Problem:" with the expected (`rrule` derived) and actual finite difference results.
The Problem lies with the cotangent corresponding to input 2 of `rrule`, which is the first cotangent as expected. 

## Scalar example

For functions with a single argument and a single output, such as e.g. ReLU,
```jldoctest ex
function relu(x::Real)
    return max(0, x)
end

# output
relu (generic function with 1 method)
```
with the `frule` and `rrule` defined with the help of `@scalar_rule` macro
```jldoctest ex
@scalar_rule relu(x::Real) x <= 0 ? zero(x) : one(x)

# output

```

`test_scalar` function is provided to test both the `frule` and the `rrule` with a single
call.
```jldoctest ex
julia> test_scalar(relu, 0.5);
Test Summary:            | Pass  Total  Time
test_scalar: relu at 0.5 |   12     12  1.2s


julia> test_scalar(relu, -0.5);
Test Summary:             | Pass  Total  Time
test_scalar: relu at -0.5 |   12     12  0.0s

```

## Testing constructors and functors (callable objects)

Testing constructor and functors works as you would expect. For struct `Foo`,
```julia
struct Foo
    a::Float64
end
(f::Foo)(x) = return f.a + x
Base.length(::Foo) = 1
Base.iterate(f::Foo) = iterate(f.a)
Base.iterate(f::Foo, state) = iterate(f.a, state)
```

after defining the constructor and functor `f/rule`s,

```julia
function ChainRulesCore.rrule(::Type{Foo}, val) # constructor rrule
    y = Foo(val)
    Foo_pb(ΔFoo) = (NoTangent(), unthunk(ΔFoo).a)
    return y, Foo_pb
end

function ChainRulesCore.rrule(foo::Foo, val) # functor rrule
    y = foo(val)
    function foo_pb(Δ)
        Δut = unthunk(Δ)
        return (Tangent{Foo}(;a=Δut), Δut)
    end
    return y, foo_pb
end
```

both `f/rrule`s can be tested by
```julia
test_rrule(Foo, rand()) # constructor

foo = Foo(rand())
test_rrule(foo, rand()) # functor

# it is also possible to provide tangents for `foo` explicitly
test_frule(foo ⊢ Tangent{Foo}(;a=rand()), rand())
```

## Specifying Tangents
[`test_frule`](@ref) and [`test_rrule`](@ref) allow you to specify the tangents used for testing.
By default, tangents will be automatically generated via `FiniteDifferences.rand_tangent`.
To explicitly specify a tangent, pass in `x ⊢ Δx`, where `x` is the primal and `Δx` is the tangent, in the place of the primal inputs.
(You can enter [`⊢`](@ref) via `\vdash` + tab in the Julia REPL and supporting editors.)
A special case of this is that if you specify it as `x ⊢ NoTangent()` then finite differencing will not be used on that input.
Similarly, by setting the `output_tangent` keyword argument, you can specify the tangent for the primal output.

This can be useful when the default provided `FiniteDifferences.rand_tangent` doesn't produce the desired tangent for your type.
For example, the default tangent for an `Int` is `NoTangent()`, which is correct e.g. when the `Int` represents a discrete integer like in indexing.
But if you are testing something where the `Int` is actually a special case of a real number, then you would want to specify the tangent as a `Float64`.

Care must be taken when manually specifying tangents.
In particular, when specifying the input tangents to [`test_frule`](@ref) and the output tangent to [`test_rrule`](@ref).
As these tangents are used to seed the derivative computation.
Inserting inappropriate zeros can thus hide errors.

## Testing higher order functions

Higher order functions, such as `map`, take a function (or a functor) `f` as an argument.
`f/rrule`s for these functions call back into AD to compute the `f/rrule` of `f`.
To test these functions, we use a dummy AD system, which simply calls the appropriate rule for `f` directly.
For this reason, when testing `map(f, collection)`, the rules for `f` need to be defined.
The `RuleConfig` for this dummy AD system is the default one, and does not need to be provided.
```julia
test_rrule(map, x->2x [1, 2, 3.]) # fails, because there is no rrule for x->2x

mydouble(x) = 2x
function ChainRulesCore.rrule(::typeof(mydouble), x)
    mydouble_pullback(ȳ) = (NoTangent(), ȳ)
    return mydouble(x), mydouble_pullback
end
test_rrule(map, mydouble, [1, 2, 3.]) # works
```

## Testing AD systems

The gradients computed by AD systems can be also be tested using `test_rrule`.
To do that, one needs to provide an `rrule_f`/`frule_f` keyword argument, as well as the `RuleConfig` used by the AD system.
`rrule_f` is a function that wraps the gradient computation by an AD system in the same API as the `rrule`.
`RuleConfig` is an object that determines which sets of rules are defined for an AD system.
For example, let's say we have a complicated function

```julia
function complicated(x, y)
    return do(x + y) + some(x) * hard(y) + maths(x * y)
end
```

that we do not know an `rrule` for, and we want to check whether the gradients provided by the AD system are correct.

To test gradients computed by the AD system you need to provide a `rrule_f` function that acts like calling `rrule` but use AD rather than a defined rule.
This has the exact same semantics as is required to overload `ChainRulesCore.rrule_via_ad`, thus almost all systems doing so should just overload that, and pass in that and the config, and then trigger `test_rrule(MyADConfig, f, xs; rrule_f = ChainRulesCore.rrule_via_ad)`.
See more info on `rrule_via_ad` and the rule configs in the [ChainRules documentation](https://juliadiff.org/ChainRulesCore.jl/stable/config.html).
For some AD systems (e.g. Zygote) `rrule_via_ad` already exists.
If it does not exist, see [How to write `rrule_via_ad` function](#How-to-write-rrule_via_ad-function) section below.

We use the `test_rrule` function to test the gradients using the config used by the AD system
```julia
config = MyAD.CustomRuleConfig()
test_rrule(config, complicated, 2.3, 6.1; rrule_f=rrule_via_ad)
```
by providing the rule config and specifying the `rrule_via_ad` as the `rrule_f` keyword argument.


### How to write `rrule_via_ad` function

`rrule_via_ad` will use the AD system to compute gradients and will package them in the `rrule`-like API.

Let's say the AD package uses some custom differential types and does not provide a gradient w.r.t. the function itself.
In order to make the pullback compatible with the `rrule` API we need to add a `NoTangent()` to represent the differential w.r.t. the function itself.
We also need to transform the `ChainRules` differential types to the custom types (`cr2custom`) before feeding the `Δ` to the AD-generated pullback, and back to `ChainRules` differential types when returning from the `rrule` (`custom2cr`).

```julia
function rrule_via_ad(config::MyAD.CustomRuleConfig, f::Function, args...)
    y, ad_pullback = MyAD.pullback(f, args...)
    function rrulelike_pullback(Δ)
        diffs = custom2cr(ad_pullback(cr2custom(Δ)))
        return NoTangent(), diffs...
    end
        
    return y, rrulelike_pullback
end

custom2cr(differential) = ...
cr2custom(differential) = ...
```

## Custom finite differencing

If a package is using a custom finite differencing method of testing the `frule`s and `rrule`s, `test_approx` function provides a convenient way of comparing [various types](https://www.juliadiff.org/ChainRulesCore.jl/dev/design/many_differentials.html#Design-Notes:-The-many-to-many-relationship-between-differential-types-and-primal-types.) of differentials.

It is effectively `(a, b) -> @test isapprox(a, b)`, but it preprocesses `thunk`s and `ChainRules` differential types `ZeroTangent()`, `NoTangent()`, and `Tangent`, such that the error messages are helpful.

For example,
```julia
test_approx((@thunk 2*2.0), 4.1)
```
shows both the expression and the evaluated `thunk`s
```julia
   Expression: isapprox(actual, expected; kwargs...)
   Evaluated: isapprox(4.0, 4.1)
ERROR: There was an error during testing
```
compared to
```julia
julia> @test isapprox(@thunk 2*2.0, 4.0)
Test Failed at REPL[52]:1
  Expression: isapprox(#= REPL[52]:1 =# @thunk((2 * 2.0, 4.0)))
   Evaluated: isapprox(Thunk(var"#24#25"()))
ERROR: There was an error during testing
```
which should have passed the test.

## Inference tests

By default, all functions for testing rules check whether the output type (as well as that of the pullback for `rrule`s) can be completely inferred, such that everything is type stable:

```julia
julia> function ChainRulesCore.rrule(::typeof(abs), x)
           abs_pullback(Δ) = (NoTangent(), x >= 0 ? Δ : big(-1.0) * Δ)
           return abs(x), abs_pullback
       end

julia> test_rrule(abs, 1.)
test_rrule: abs on Float64: Error During Test at /home/runner/work/ChainRulesTestUtils.jl/ChainRulesTestUtils.jl/src/testers.jl:170
  Got exception outside of a @test
  return type Tuple{ChainRulesCore.NoTangent, Float64} does not match inferred return type Tuple{ChainRulesCore.NoTangent, Union{Float64, BigFloat}}
[...]
```

This can be disabled on a per-rule basis using the `check_inferred` keyword argument:

```julia
julia> test_rrule(abs, 1.; check_inferred=false)
Test Summary:              | Pass  Total
test_rrule: abs on Float64 |    5      5
Test.DefaultTestSet("test_rrule: abs on Float64", Any[], 5, false, false)
```

This behavior can also be overridden globally by setting the environment variable `CHAINRULES_TEST_INFERRED` before ChainRulesTestUtils is loaded or by changing `ChainRulesTestUtils.TEST_INFERRED[]` from inside Julia.
ChainRulesTestUtils can detect whether a test is run as part of [PkgEval](https://github.com/JuliaCI/PkgEval.jl) and in this case disables inference tests automatically. Packages can use [`@maybe_inferred`](@ref) to get the same behavior for other inference tests.
